//#define USE_UNBANNER
//#define LIMIT_WEAPONCOUNT
#define USE_CLUSTERING


// Graphics

inline void BotSession::DrawTile(DWORD x, DWORD y, DWORD DestX, DWORD DestY, DWORD SrcX, DWORD SrcY, DWORD W, DWORD H)
{
	register BYTE v = Map[(y << 10) + x];

	if ((v == 0x00) || (v == 0xAA))			// Nothing / turf flags
		return;

	if ((v >= 0xA2) && (v <= 0xA5))			// Horizontal doors
		TileSet.OpaqueBlitEx( Window.Backbuffer,
							  DestX,
							  DestY,
							  SrcX,
							  SrcY,
							  W,
							  H,
							  AnimationFrame % 4 + 0xA1 );
	else if ((v >= 0xA6) && (v <= 0xA9))	// Vertical doors
		TileSet.OpaqueBlitEx( Window.Backbuffer,
							  DestX,
							  DestY,
							  SrcX,
							  SrcY,
							  W,
							  H,
							  AnimationFrame % 4 + 0xA5 );
	else if (v == 0xAC)						// Goals
		GoalSet.OpaqueBlitEx( Window.Backbuffer,
							  DestX,
							  DestY,
							  SrcX,
							  SrcY,
							  W,
							  H,
							  AnimationFrame % 9 );
	else if (v <= 0xBE)						// Normal tiles
		TileSet.OpaqueBlitEx( Window.Backbuffer,
							  DestX,
							  DestY,
							  SrcX,
							  SrcY,
							  W,
							  H,
							  v - 1 );
	else if (v >= 0xD8 && v <= 0xDA)		// Asteroids
		Asteroids.OpaqueBlitEx( Window.Backbuffer,
							    DestX,
							    DestY,
							    SrcX,
							    SrcY,
							    W,
							    H,
							    AnimationFrame % 30 );
	else if (v == 0xDB)						// Station
		Station.OpaqueBlitEx( Window.Backbuffer,
							  DestX,
							  DestY,
							  SrcX,
							  SrcY,
							  W,
							  H,
							  AnimationFrame % 10 );
	else if (v == 0xDC)						// Wormhole
		Wormhole.OpaqueBlitEx( Window.Backbuffer,
							   DestX,
							   DestY,
							   SrcX,
							   SrcY,
							   W,
							   H,
							   AnimationFrame % 24 );
}

inline void BotSession::DrawTile(DWORD x, DWORD y, DWORD DestX, DWORD DestY)
{
	register BYTE v = Map[(y << 10) + x];

	if ((v == 0x00) || (v == 0xAA))			// Nothing / turf flags
		return;

	if ((v >= 0xA2) && (v <= 0xA5))			// Horizontal doors
		TileSet.OpaqueBlit( Window.Backbuffer,
							DestX,
							DestY,
							AnimationFrame % 4 + 0xA1 );
	else if ((v >= 0xA6) && (v <= 0xA9))	// Vertical doors
		TileSet.OpaqueBlit( Window.Backbuffer,
							DestX,
							DestY,
							AnimationFrame % 4 + 0xA5 );
	else if (v == 0xAC)						// Goals
		GoalSet.OpaqueBlit( Window.Backbuffer,
							DestX,
							DestY,
							AnimationFrame % 9 );
	else if (v <= 0xBE)						// Normal tiles
		TileSet.OpaqueBlit( Window.Backbuffer,
						    DestX,
						    DestY,
						    v - 1 );
	else if (v >= 0xD8 && v <= 0xDA)		// Asteroids
		Asteroids.OpaqueBlit( Window.Backbuffer,
							  DestX,
							  DestY,
							  AnimationFrame % 30 );
	else if (v == 0xDB)						// Station
		Station.OpaqueBlit( Window.Backbuffer,
						    DestX,
						    DestY,
						    AnimationFrame % 10 );
	else if (v == 0xDC)						// Wormhole
		Wormhole.OpaqueBlit( Window.Backbuffer,
							 DestX,
							 DestY,
							 AnimationFrame % 24 );
}

void BotSession::DrawTiledBackdrop()
{
	DWORD OffsetX	= TRIM(Window.HalfWidth,  Window.CenterX);			// Offset from screen origin X where drawing starts
	DWORD OffsetY	= TRIM(Window.HalfHeight, Window.CenterY);			// Offset from screen origin Y where drawing starts

	DWORD RegionWidth	= Window.Width  - TRIM(Window.CenterX + (Window.HalfWidth),  MapWidth)  - OffsetX;	// Width of region (so you can't go off the map)
	DWORD RegionHeight	= Window.Height - TRIM(Window.CenterY + (Window.HalfHeight), MapHeight) - OffsetY;	// Height of region (so you can't go off the map)

	DWORD OriginX	= Window.CenterX + OffsetX - Window.HalfWidth;		// Origin X on map
	DWORD OriginY	= Window.CenterY + OffsetY - Window.HalfHeight;		// Origin Y on map

	DWORD TileX	= OriginX >> 4;										// Relative Center's X coords
	DWORD TileY	= OriginY >> 4;										// Relative Center's Y coords

	DWORD PixelX	= OriginX % 16;				// ScreenX offset from the relative Center's tile coords
	DWORD PixelY	= OriginY % 16;				// ScreenY offset from the relative Center's tile coords

	DWORD FarX	= (OriginX + RegionWidth)  % 16;	// Right border width
	DWORD FarY	= (OriginY + RegionHeight) % 16;	// Bottom border height

	DWORD LeapX	= 16 - PixelX;					// Left border width
	DWORD LeapY	= 16 - PixelY;					// Top border height

	DWORD CountX	= (RegionWidth  - (FarX + LeapX)) >> 4;			// Full horizontal tile count
	DWORD CountY	= (RegionHeight - (FarY + LeapY)) >> 4;			// Full vertical tile count

	DWORD AdjustX	= (CountX == 268435455) ? RegionWidth  : LeapX;	// Modify width of draw area to fit smaller regions
	DWORD AdjustY	= (CountY == 268435455) ? RegionHeight : LeapY;	// Modify height of draw area to fit smaller regions

	register DWORD x;	// Index for horizontal tile stepping
	register DWORD y;	// Index for vertical tile stepping
	register DWORD dx;	// Horizontal draw offset stepping in pixels
	register DWORD dy;	// Vertical draw offset stepping in pixels
	register DWORD rs = TileX + CountX + 1;		// Offset to the right
	register DWORD bs = TileY + CountY + 1;		// Offset to the bottom
	register DWORD prs = OffsetX + RegionWidth - FarX;	// Pixels to the right
	register DWORD pbs = OffsetY + RegionHeight - FarY;	// Pixels to the bottom
	register DWORD olx = OffsetX + LeapX;	// Draw offset in X for edges
	register DWORD oly = OffsetY + LeapY;	// Draw offset in Y for edges

	// Upper left
	DrawTile(TileX, TileY, OffsetX, OffsetY, PixelX, PixelY, AdjustX, AdjustY);

	if (CountY != 268435455)
	{
		// Left side
		for (y = 1, dy = oly; y <= CountY; y++, dy += 16)
			DrawTile(TileX, TileY + y, OffsetX, dy, PixelX, 0, AdjustX, 16);

		// Lower left
		DrawTile(TileX, bs, OffsetX, pbs, PixelX, 0, AdjustX, FarY);
	}

	if (CountX != 268435455)
	{
		// Top side
		for (x = 1, dx = olx; x <= CountX; x++, dx += 16)
			DrawTile(TileX + x, TileY, dx, OffsetY, 0, PixelY, 16, AdjustY);

		// Upper right
		DrawTile(rs, TileY, prs, OffsetY, 0, PixelY, FarX, AdjustY);

		if (CountY != 268435455)
		{
			// Lower right
			DrawTile(rs, bs, prs, pbs, 0, PixelY, FarX, AdjustY);

			// Bottom side
			for (x = 1, dx = olx; x <= CountX; x++, dx += 16)
				DrawTile(TileX + x, bs, dx, pbs, 0, 0, 16, FarY);

			// Right side
			for (y = 1, dy = oly; y <= CountY; y++, dy += 16)
				DrawTile(rs, TileY + y, prs, dy, 0, 0, FarX, 16);

			// In sides
			for (x = 1, dx = olx; x <= CountX; x++, dx += 16)
			for (y = 1, dy = oly; y <= CountY; y++, dy += 16)
				DrawTile(TileX + x, TileY + y, dx, dy);
		}
	}
}


// Threads

void BotSession::ResendThread()
{
	while (hResend == 0) { Sleep(10); }

	// Resend queued messages
	while (hResend)
	{
		// Check for host KickOff
/*		if (HasSession && (GetTickCount() - LastTicks >= DWORD(Settings.S2CNoDataKickoutDelay * 10)))
		{
			Chat.AddMessage("DISCONNECTED: Not receiving any data from host.", CHAT_Red);

			Running = false;
			Disconnect(false);
			ResetSession();
		}
*/
LockClass();
		// Resend messages
#ifdef USE_CLUSTERING
		StartCluster();
#endif
			ResendQueue();

			// Check if it is time to send another position packet
			if ((SendingPosition) && (GetTickCount() - LastPositionUpdate) > DWORD(Settings.SendPositionDelay * 10))
			{
				SendPosition();
			}

			// Check if 00 01 needs to be resent
			if ((HasSession == false) && (GetTickCount() - LastSessionSend > 5000))
			{
				Connect(Remote.IP, htons(Remote.Port));
			}
#ifdef USE_CLUSTERING
		EndCluster();
#endif

		// Check if game objects have expired
		PollBricksForKickOff();
		PollBallsForKickOff();
		PollFlagsForKickOff();
		PollWeaponsForKickOff();

UnlockClass();

		Sleep(10);
	}
}

void BotSession::RecvThread()
{
	while (hReceive == 0) { Sleep(10); }

	// Receive queued messages
	INADDR SockAddy;
	int FromLen = 16;
	int datalen;
	DWORD flags = 0;
	BYTE buffer[520];

	HANDLE event = WSACreateEvent();
	WSAEventSelect(SocketID, event, FD_READ);

	while (hReceive)
	{
		if (WSAWaitForMultipleEvents(1, &event, false, 0, true) == WSA_WAIT_EVENT_0)
		{
			datalen = recvfrom(SocketID, (char*)buffer, 520, 0, (sockaddr*)&SockAddy, &FromLen);

			if (datalen > 0)
			{
				// Find or Create host

				if (SockAddy == Remote)
				{
					TotalRecvd++;
					S2CFastCurrent++;
					Decrypt(buffer, datalen);
LockClass();
#ifdef USE_CLUSTERING
					StartCluster();
#endif
						Route(buffer, datalen);
#ifdef USE_CLUSTERING
					EndCluster();
#endif
UnlockClass();
				}
				else
				{
					Chat.AddMessage("WARNING: Unsolicited packet recv'd from an unknown host.", CHAT_Orange);
				}

			}
		}

		SleepEx(10, true);
	}

	WSACloseEvent(event);
}

void BotSession::GraphicsThread()
{
	while (hGraphics == 0) { Sleep(10); }

	DWORD LastTime;
	DWORD DiffTime;

	DWORD FrameTime = GetTickCount();
	DWORD FrameCount = 0;
	DWORD FPS = 0;

	while (hGraphics)
	{
		// Render loop

		Running = Window.Open;

		AdvanceFrame();

	if (Window.Minimized)
	{
LockClass();
		LastTime = GetTickCount();

		// When the window is minimized, don't render anything
		if (Me)
		{
			// Update player coords
			Me->x = Window.CenterX;
			Me->y = Window.CenterY;

			_listnode <Player> * parse = PlayerList.head;
			while (parse)
			{
				Player * player = parse->item;
				if (player != Me) player->TraceProjectile(Map);
				parse = parse->next;
			}

			// Update weapon coords
			_listnode <Weapon> * wparse = WeaponList.head;
			while (wparse)
			{
				Weapon * weapon = wparse->item;
				weapon->AdvanceFrame();
				bool Bounced = weapon->TraceProjectile(Map);
				wparse = wparse->next;

				if (Bounced && (weapon->BounceCounter == 0))
					WeaponList.Delete(weapon, false);
				else if ((Bounced) && (weapon->Type.Type == PROJ_InactiveBullet))
					weapon->Type.Type = PROJ_Burst;
			}

			// Update powerball coords
			_listnode <Powerball> * pparse = SoccerList.head;
			while (pparse)
			{
				Powerball * ball = pparse->item;
				pparse = pparse->next;

				if (ball->Carried == false)
				{
					ball->AdvanceFrame();
					ball->TraceProjectile(Map);
				}
			}

			// Draw flags
			_listnode <FlagData> * fparse = FlagList.head;
			while (fparse)
			{
				FlagData * flag = fparse->item;
				flag->AdvanceFrame();
				fparse = fparse->next;
			}

			// Draw impacts
			_listnode <WeaponImpact> * iparse = ImpactList.head;
			while (iparse)
			{
				WeaponImpact * impact = iparse->item;
				impact->AdvanceFrame();
				iparse = iparse->next;
			}

			// Draw bricks
			_listnode <Brick> * bparse = BrickList.head;
			while (bparse)
			{
				Brick * brick = bparse->item;
				brick->AdvanceFrame();
				bparse = bparse->next;
			}
		}
UnlockClass();
	}
	else
	{
		// When the window is not minimized, render everything
		Window.ClearSurface();

LockClass();
		LastTime = GetTickCount();

		Starfield.Render(2, 100);
		Starfield.Render(1, 200);
		if (HasSession) DrawTiledBackdrop();

		if (Me)
		{
			// Update player coords
			Me->x = Window.CenterX;
			Me->y = Window.CenterY;

			_listnode <Player> * parse = PlayerList.head;
			while (parse)
			{
				Player * player = parse->item;
				if (player != Me) player->TraceProjectile(Map);
				parse = parse->next;

				if (player->x != 0)
				{
					if ((DISTANCE(player->x, Me->x) < Window.HalfWidth) && (DISTANCE(player->y, Me->y) < Window.HalfHeight))
					{
						if (player->AttachedTo)
						{
							TurretSet.TransBlit(Window.Backbuffer, Window.HalfWidth - Me->x + player->x - 20, Window.HalfHeight - Me->y + player->y - 20, player->D);
						}
						else
						{
							ShipSet.TransBlit(Window.Backbuffer, Window.HalfWidth - Me->x + player->x - 18, Window.HalfHeight - Me->y + player->y - 18, player->D + (player->ShipType * 40));
						}
					}
				}
			}

			// Update weapon coords
			_listnode <Weapon> * wparse = WeaponList.head;
			_listnode <Weapon> * wkparse;
			while (wparse)
			{
				wkparse = wparse;
				Weapon * weapon = wparse->item;
				weapon->AdvanceFrame();
				bool Bounced = weapon->TraceProjectile(Map);
				wparse = wparse->next;

				if (Bounced && (weapon->BounceCounter == 0))
				{
					BYTE wt = weapon->Type.Type;
					if ((wt == PROJ_Bomb) || (wt == PROJ_PBomb))
					{
						WeaponImpact * wi = new WeaponImpact(weapon->x - 16, weapon->y - 16, PROJ_Bomb, 36);
						wi->SetFrameRate(50);
						ImpactList.Append(wi);
					}
					else if ((wt == PROJ_Bullet) || (wt == PROJ_Burst) || (wt == PROJ_Shrapnel))
					{
						WeaponImpact * wi = new WeaponImpact(weapon->x + 16, weapon->y + 16, PROJ_Bullet, 7);
						wi->SetFrameRate(50);
						ImpactList.Append(wi);
					}

					WeaponList.Delete(wkparse, false);
				}
				else
				{
					if ((weapon->Type.Type == PROJ_InactiveBullet) && (Bounced))
					{
						weapon->Type.Type = PROJ_Burst;
					}

					if ((DISTANCE(weapon->x, Me->x) < Window.HalfWidth) && (DISTANCE(weapon->y, Me->y) < Window.HalfHeight))
					{
						switch (weapon->Type.Type)
						{
						// Bullet types
						case PROJ_Bullet:
							BulletSet.TransBlit(Window.Backbuffer, Window.HalfWidth - Me->x + weapon->x - 3, Window.HalfHeight - Me->y + weapon->y - 3, (weapon->Type.Level << 2) + (weapon->AnimationFrame % 4));
							break;
						case PROJ_BBullet:
							BulletSet.TransBlit(Window.Backbuffer, Window.HalfWidth - Me->x + weapon->x - 3, Window.HalfHeight - Me->y + weapon->y - 3, 20 + (weapon->Type.Level << 2) + (weapon->AnimationFrame % 4));
							break;
						// Burst
						case PROJ_InactiveBullet:
							BulletSet.TransBlit(Window.Backbuffer, Window.HalfWidth - Me->x + weapon->x - 3, Window.HalfHeight - Me->y + weapon->y - 3, 16 + (weapon->AnimationFrame % 4));
							break;
						case PROJ_Burst:
							BulletSet.TransBlit(Window.Backbuffer, Window.HalfWidth - Me->x + weapon->x - 3, Window.HalfHeight - Me->y + weapon->y - 3, 36 + (weapon->AnimationFrame % 4));
							break;
						// Shrapnel
						case PROJ_Shrapnel:
							ShrapSet.TransBlit(Window.Backbuffer, Window.HalfWidth - Me->x + weapon->x - 4, Window.HalfHeight - Me->y + weapon->y - 4, 0 + (weapon->AnimationFrame % 10));
							break;
						// Decoy
						case PROJ_Decoy:
							ShipSet.TransBlit(Window.Backbuffer, Window.HalfWidth - Me->x + weapon->x - 18, Window.HalfHeight - Me->y + weapon->y - 18, (40 - weapon->Owner->D) + (weapon->Owner->ShipType * 40));
							break;
						// Repel
						case PROJ_Repel:
							RepelSet.TransBlit(Window.Backbuffer, Window.HalfWidth - Me->x + weapon->x - 48, Window.HalfHeight - Me->y + weapon->y - 48, (weapon->AnimationFrame % 10));
							break;
						// Bomb types
						case PROJ_Bomb:
						case PROJ_PBomb:
							{
								WORD Graphic = (weapon->Type.Level * 10) + (weapon->AnimationFrame % 10);

								if (weapon->Type.FireType)
								{
									if (weapon->Type.EMP)
										Graphic += 40;

									MineSet.TransBlit(Window.Backbuffer, Window.HalfWidth - Me->x + weapon->x - 8, Window.HalfHeight - Me->y + weapon->y - 8, Graphic);
								}
								else
								{
									if (weapon->Type.EMP)
										Graphic += 40;
									else if (weapon->Type.Bouncing)
										Graphic += 80;

									BombSet.TransBlit(Window.Backbuffer, Window.HalfWidth - Me->x + weapon->x - 8, Window.HalfHeight - Me->y + weapon->y - 8, Graphic);
								}
							}
							break;
						case PROJ_Thor:
							BombSet.TransBlit(Window.Backbuffer, Window.HalfWidth - Me->x + weapon->x - 8, Window.HalfHeight - Me->y + weapon->y - 8, 120 + (weapon->AnimationFrame % 10));
							break;
						};
					}
				}
			}

			// Update powerball coords
			_listnode <Powerball> * pparse = SoccerList.head;
			while (pparse)
			{
				Powerball * ball = pparse->item;
				pparse = pparse->next;

				if (ball->Carried == false)
				{
					ball->AdvanceFrame();
					ball->TraceProjectile(Map);

					if ((DISTANCE(ball->x, Me->x) < Window.HalfWidth) && (DISTANCE(ball->y, Me->y) < Window.HalfHeight))
					{
						BallSet.TransBlit(Window.Backbuffer, Window.HalfWidth - Me->x + ball->x - 8, Window.HalfHeight - Me->y + ball->y - 8, 0 + (ball->AnimationFrame % 10));
					}
				}
			}

			// Draw flags
			_listnode <FlagData> * fparse = FlagList.head;
			while (fparse)
			{
				FlagData * flag = fparse->item;
				flag->AdvanceFrame();
				fparse = fparse->next;

				if (flag->Carried == false)
				{
					if ((DISTANCE(flag->x, Me->x) < Window.HalfWidth) && (DISTANCE(flag->y, Me->y) < Window.HalfHeight))
					{
						FlagSet.TransBlit(Window.Backbuffer, Window.HalfWidth - Me->x + flag->x, Window.HalfHeight - Me->y + flag->y, 0 + (flag->AnimationFrame % 10));
					}
				}
			}

			// Draw bricks
			_listnode <Brick> * bparse = BrickList.head;
			while (bparse)
			{
				Brick * brick = bparse->item;
				brick->AdvanceFrame();
				bparse = bparse->next;

				if ((DISTANCE(brick->x, Me->x) < Window.HalfWidth) && (DISTANCE(brick->y, Me->y) < Window.HalfHeight))
				{
					BrickSet.TransBlit(Window.Backbuffer, Window.HalfWidth - Me->x + brick->x, Window.HalfHeight - Me->y + brick->y, brick->AnimationFrame % 10);
				}
			}

			// Draw impacts
			_listnode <WeaponImpact> * iparse = ImpactList.head;
			_listnode <WeaponImpact> * kparse;
			while (iparse)
			{
				kparse = iparse;
				WeaponImpact * impact = iparse->item;
				impact->AdvanceFrame();
				iparse = iparse->next;

				if (impact->AnimationFrame == impact->TotalFrames)
				{
					ImpactList.Delete(kparse, false);
				}
				else
				{
					if ((DISTANCE(impact->x, Me->x) < Window.HalfWidth) && (DISTANCE(impact->y, Me->y) < Window.HalfHeight))
					{
						if (impact->WeaponType == PROJ_Bomb)
						{
							ExplosionSet.TransBlit(Window.Backbuffer, Window.HalfWidth - Me->x + impact->x - 8, Window.HalfHeight - Me->y + impact->y - 8, impact->AnimationFrame);
						}
						else
						{
							ImpactSet.TransBlit(Window.Backbuffer, Window.HalfWidth - Me->x + impact->x - 24, Window.HalfHeight - Me->y + impact->y - 24, impact->AnimationFrame);
						}
					}
				}
			}

			if (Me->ShipType != ssSpectator)
			{
				// Energy bar
				DWORD Left = Window.Width >> 2;
				DWORD Right = (Left << 1) + Left;
				DWORD MaxPos = Left + ((Right - Left) * TRIMLOWER(Me->mEnergy, Me->Settings->MaximumEnergy)) / Me->Settings->MaximumEnergy + 1;
				DWORD EnergyWidth = ((Right - Left) * TRIMLOWER(Me->cEnergy, Me->Settings->MaximumEnergy)) / Me->Settings->MaximumEnergy;

				Window.Lock();
					// Draw bars on either side
					for (int i = 0; i < 6; i++)
					{
						Window.SetPixel(MaxPos, i, 100, 100, 100);
						Window.SetPixel(Left, i, 255, 255, 255);
						Window.SetPixel(Right, i, 255, 255, 255);
					}

					// Fill in-between
					for (DWORD x = 1; x < EnergyWidth; x++)
					for (DWORD y = 1; y < 5; y++)
					{
						Window.SetPixel(x + Left, y, 110, 90, 255);
					}

				Window.Unlock();

				// Item status
				DWORD Tile, BaseY;

				BaseY = (Window.Height - (ItemSet.tile_height * 7)) >> 1;
				// Bursts
				if (Me->cBurst)
				{
					ItemSet.TransBlit(Window.Backbuffer, 0, BaseY, 30);
					if (Me->cBurst > 1) ItemFont.TransBlit(Window.Backbuffer, 23, BaseY + 5, (WORD) TRIMLOWER(Me->cBurst, 10));
				}
				// Repels
				if (Me->cRepel)
				{
					ItemSet.TransBlit(Window.Backbuffer, 0, BaseY + ItemSet.tile_height, 31);
					if (Me->cRepel > 1) ItemFont.TransBlit(Window.Backbuffer, 23, BaseY + ItemSet.tile_height + 5, (WORD) TRIMLOWER(Me->cRepel, 10));
				}
				// Decoys
				if (Me->cDecoy)
				{
					ItemSet.TransBlit(Window.Backbuffer, 0, BaseY + (ItemSet.tile_height << 1), 40);
					if (Me->cDecoy > 1) ItemFont.TransBlit(Window.Backbuffer, 23, BaseY + (ItemSet.tile_height << 1) + 5, (WORD) TRIMLOWER(Me->cDecoy, 10));
				}
				// Thors
				if (Me->cThor)
				{
					ItemSet.TransBlit(Window.Backbuffer, 0, BaseY + ItemSet.tile_height * 3, 41);
					if (Me->cThor > 1) ItemFont.TransBlit(Window.Backbuffer, 23, BaseY + (ItemSet.tile_height * 3) + 5, (WORD) TRIMLOWER(Me->cThor, 10));
				}
				// Bricks
				if (Me->cBrick)
				{
					ItemSet.TransBlit(Window.Backbuffer, 0, BaseY + (ItemSet.tile_height << 2), 42);
					if (Me->cBrick > 1) ItemFont.TransBlit(Window.Backbuffer, 23, BaseY + (ItemSet.tile_height << 2) + 5, (WORD) TRIMLOWER(Me->cBrick, 10));
				}
				// Rockets
				if (Me->cRocket)
				{
					ItemSet.TransBlit(Window.Backbuffer, 0, BaseY + ItemSet.tile_height * 5, 43);
					if (Me->cRocket > 1) ItemFont.TransBlit(Window.Backbuffer, 23, BaseY + (ItemSet.tile_height * 5) + 5, (WORD) TRIMLOWER(Me->cRocket, 10));
				}
				// Portals
				if (Me->cPortal)
				{
					ItemSet.TransBlit(Window.Backbuffer, 0, BaseY + ItemSet.tile_height * 6, 46);
					if (Me->cPortal > 1) ItemFont.TransBlit(Window.Backbuffer, 23, BaseY + (ItemSet.tile_height * 6) + 5, (WORD) TRIMLOWER(Me->cPortal, 10));
				}

				BaseY = (Window.Height - (ItemSet.tile_height * 6)) >> 1;
				// Guns
				if (Me->lGun)
				{
					if (Me->hBouncingBullets)
						Tile = 9;
					else
						Tile = 0;
					if (Me->hMultifire)
					{
						if (Me->bMultifire)
							Tile += 3;
						else
							Tile += 6;
					}
					ItemSet.TransBlit(Window.Backbuffer, Window.Width - ItemSet.tile_width, BaseY + ItemSet.tile_height * 0, WORD(Tile + Me->lGun - 1));
				}
				// Bombs
				if (Me->lBomb)
				{
					Tile = 18;
					if (Me->cShrap)
						Tile += 6;
					if (Me->hProxbombs)
						Tile += 3;
					ItemSet.TransBlit(Window.Backbuffer, Window.Width - ItemSet.tile_width, BaseY + ItemSet.tile_height * 1, WORD(Tile + Me->lBomb - 1));
				}
				// Stealth
				if (Me->hStealth) ItemSet.TransBlit(Window.Backbuffer, Window.Width - ItemSet.tile_width, BaseY + ItemSet.tile_height * 2, Me->bStealth ? 32 : 33);
				// Cloak
				if (Me->hCloak) ItemSet.TransBlit(Window.Backbuffer, Window.Width - ItemSet.tile_width, BaseY + ItemSet.tile_height * 3, Me->bStealth ? 34 : 35);
				// X-Radar
				if (Me->hXRadar) ItemSet.TransBlit(Window.Backbuffer, Window.Width - ItemSet.tile_width, BaseY + ItemSet.tile_height * 4, Me->bStealth ? 36 : 37);
				// Antiwarp
				if (Me->hAntiwarp) ItemSet.TransBlit(Window.Backbuffer, Window.Width - ItemSet.tile_width, BaseY + ItemSet.tile_height * 5, Me->bStealth ? 38 : 39);

				// Status box
				StatusBox.TransBlit(Window.Backbuffer, Window.Width - StatusBox.tile_width, 5, 0);
				NumberSet1.Move(Window.Width - 12, 0);
				NumberSet1.Render((WORD)Me->cEnergy);
				NumberSet2.Move(Window.Width - 12, 57);
				NumberSet2.Render((WORD)Me->cBounty);
				NumberSet2.Move(Window.Width - 12, 33);
				NumberSet2.Render((WORD)Me->Frequency);
				NumberSet2.Move(Window.Width - 33, 45);
				NumberSet2.Render(0);
				NumberSet2.Move(Window.Width - 12, 45);
				NumberSet2.Render(0);
			}

			// Coord indicator above radar
			char Letter[2];
			Letter[0] = 65 + (Me->x * 5 / (1024 << 2));
			Letter[1] = 0;
			DWORD Number = (Me->y * 5 / (1024 << 2)) + 1;

			_string s;
			s = Letter;
			s += (int) Number;

			Font.DrawOpaqueText(Window.Backbuffer, Window.Width - 50, Window.Height - 180, s.Text, CHAT_Grey);
		}
UnlockClass();

		// Radar
		Radar.Render();

		// Chat system
		Chat.BlitBuffer();

		ChatBox.Render();

		// FPS
		_string s;
		s = (int)FPS;
		Font.DrawOpaqueText(Window.Backbuffer, 0, 0, s.Text, CHAT_Orange);

		Window.Flip();

		FrameCount++;
		if (GetTickCount() - FrameTime > 1000)
		{
			FPS = FrameCount;
			FrameCount = 0;
			FrameTime = GetTickCount();
		}
	}	// Minimized Skip

		DiffTime = GetTickCount() - LastTime;

		if (DiffTime < 20)
		{
			Sleep(20 - (DWORD)DiffTime);
		}
	}
}


// SubSpace core protocol implementation

void BotSession::SetHandler(BYTE Type, bool (*function)(PacketStruct *))
{
	Router.RegisterHandler(Type, function);
}

void BotSession::SetSpecialHandler(BYTE Type, bool (*function)(PacketStruct *))
{
	SpecialRouter.RegisterHandler(Type, function);
}

void BotSession::SetTicks()
{
	LastTicks = GetTickCount();
}

LONG BotSession::SetKey(LONG Key)
{
	if (!Key) return 0;

	InitializeEncryption(Key);

	return Key;
}

void BotSession::Route(BYTE * Message, LONG Length)
{
	Router.CallHandler(Message[0], new PacketStruct(this, Message, Length));
	SetTicks();
}

void BotSession::UpdatePing(DWORD Ping)
{
	SHORT PingTime = (SHORT)Ping;
	LastPing = PingTime;

	if (AveragePing)
		AveragePing = (AveragePing + PingTime) >> 1;
	else
		AveragePing = PingTime;

	if (HighestPing < PingTime)
		HighestPing = PingTime;

	if ((LowestPing == 0) || (LowestPing > PingTime))
		LowestPing = PingTime;
}

void BotSession::ClearHandlers()
{
	Router.ClearHandlers();
	Router.RegisterHandler(0, HandleSpecial);
}

bool BotSession::CheckBacklog(PacketStruct * Packet)
{
	// ACK & Process backlog
	BYTE buffer[6];

	// Acknowledge message
	MakeACK(buffer, GetLong(Packet->Message, 2));
	Send(buffer, 6, false);

	// Process if expected
	if (GetLong(Packet->Message, 2) == RemoteStep)
	{
		// Handle given packet
		Router.CallHandler(Packet->Message[6], new PacketStruct(this, &Packet->Message[6], Packet->Length - 6));

		// Increment expected packet ID
		RemoteStep++;

		_listnode <PacketStruct> * parse = Backlog.head;

		// Search for next packet in sequence
		while (parse)
		{
			PacketStruct * ps = parse->item;

			// Check if found packet was expected
			if (GetLong(ps->Message, 2) == RemoteStep)
			{
				// Handle logged packet
				Router.CallHandler(ps->Message[6], new PacketStruct(this, &ps->Message[6], ps->Length - 6));

				// Delete backlog entry
				Backlog.Delete(parse, false);

				// Increment expected packet ID
				RemoteStep++;

				// Reset node pointer, and search again
				parse = Backlog.head;
			}
			else
				parse = parse->next;
		}

		return true;
	}

	// Add if a packet has been lost
	if (GetLong(Packet->Message, 2) > RemoteStep)
	{
		_listnode <PacketStruct> * parse = Backlog.head;

		// Search for same packet in sequence
		while (parse)
		{
			// Ignore if sent packet has been recv'd
			if (GetLong(parse->item->Message, 2) == GetLong(Packet->Message, 2))
				return true;

			parse = parse->next;
		}

		// Log recv'd packet otherwise
		Backlog.Append(Packet);
		return false;
	}

	// Ignore if already seen
	return true;
}

bool BotSession::ResendQueue()
{
	_listnode <PostlogNode> * parse = Sendlog.head;
	DWORD Ticks = GetTickCount();

	// Spider the Sendlogs
	while (parse)
	{
		PostlogNode * post = parse->item;
		parse = parse->next;

		// Validate that over 1 second has passed since last send
		if ((Ticks - post->LastSend) >= ((Ping << 1) + 10))
		{
			// Resend
			Send(post->Message, post->Length, false);
			//sendto(SocketID, (char*)post->Message, post->Length, 0, (sockaddr*)&Remote, 16);
			//TotalSent++;

			// Set 'ticks for last resend
			post->SetTime();
		}
	}

	return false;
}

void BotSession::Disconnect(bool Wait)
{
	BYTE buffer[2];
	buffer[0] = 0;
	buffer[1] = 7;

	if (Wait)
	{
		Send(buffer, 2, true);
		CloseID = LocalPost;
	}
	else
	{
		Send(buffer, 2, false);
		Send(buffer, 2, false);
	}
}

void BotSession::SendTo(BYTE * Message, DWORD Length, bool Reliable)
{
	if (Length > 482)
	{
		// Recurse to handle buffer overflows
		for (DWORD Offset = 0; Offset < Length; Offset += 480)
		{
			BYTE * buffer = new BYTE[482];

			if (Offset + 480 < Length)
			{
				// Stream body
				buffer[0] = 0;
				buffer[1] = 8;
				memcpy(buffer + 2, Message + Offset, 480);

				SendTo(buffer, 482, true);
			}
			else
			{
				// Last packet
				buffer[0] = 0;
				buffer[1] = 9;
				memcpy(buffer + 2, Message + Offset, Length - Offset);

				SendTo(buffer, Length - Offset, true);
			}

			delete buffer;
		}

		return;
	}

	if (Reliable)
	{
		DWORD	BufferLength	= Length + 6;
		BYTE  * buffer			= new BYTE[BufferLength];

		// 00 03 ID ID ID ID <Message>
		buffer[0]			= 0;
		buffer[1]			= 3;
		*(long*)&buffer[2]	= LocalPost;
		memcpy(&buffer[6], Message, Length);

		if (Sendlog.Total < 3)
		{
			// Add encrypted packet to the resend list
			LocalSend = LocalPost;
			Sendlog.Append(new PostlogNode(buffer, BufferLength, LocalPost));

			// Encrypt packet
			Encrypt(buffer, BufferLength);

			// Send it
			sendto(SocketID, (char*)buffer, BufferLength, 0, (sockaddr*)&Remote, 16);
			TotalSent++;
		}
		else
		{
			// Encrypt packet
			Encrypt(buffer, BufferLength);

			// Add encrypted packet to the message queue
			Postlog.Append(new PostlogNode(buffer, BufferLength, LocalPost));
		}

		// Set next ID
		LocalPost++;

		// Delete temporary workspace
		delete buffer;
	}
	else
	{
		// Encrypt packet
		Encrypt(Message, Length);

		// Send it
		sendto(SocketID, (char*)Message, Length, 0, (sockaddr*)&Remote, 16);
		TotalSent++;
	}
}

void BotSession::StartCluster()
{
	Clustering = true;
	TotalReliableClusters = 0;
}

void BotSession::EndCluster()
{
	DWORD Total = ClusterMessages.Total;

	// Do nothing if no packets have been sent
	if (Total == 0)
		return;

	// Send as normal in the case of one packet
	if (Total == 1)
	{
		LoggedPacket * lp = ClusterMessages.head->item;

		SendTo(lp->Message, lp->Length, lp->Reliable);

		// Clean up
		Clustering = false;
		ClusterMessages.Clear(false);

		return;
	}

	// Else prepare to do some clustering!
	DWORD Count = 0;

	BYTE buffer[520];
	DWORD len = 2;
	buffer[0] = 0x00;
	buffer[1] = 0x0E;

	_listnode <LoggedPacket> * parse = ClusterMessages.head;
	LoggedPacket * lp;

	if (TotalReliableClusters == 0)
	{
		// Ignore reliable attributes
		do
		{
			lp = parse->item;
			{
				// Make sure this message will fit
				DWORD thislen = lp->Length;

				if (thislen > 255)
				{
					// The message will not fit in a cluster, send this message
					SendTo(lp->Message, thislen, false);
				}
				else if (len + thislen + 1 > 482)	// Don't chunk it
				{
					// The message will not fit, send the current cluster
					if (Count == 1)
					{
						SendTo(buffer + 3, len - 3, false);
					}
					else
					{
						SendTo(buffer, len, false);
					}

					// Start a new one with this message
					buffer[2] = (BYTE)thislen;
					memcpy(buffer + 3, lp->Message, thislen);
					len = 3 + thislen;
					Count = 1;
				}
				else
				{
					// The message will fit, concatenate it
					buffer[len] = thislen;
					memcpy(buffer + len + 1, lp->Message, thislen);
					len += (thislen + 1);
					Count++;
				}
			}
			parse = parse->next;

		} while (parse);

		// Send the cluster if there's anything in it
		if (Count != 0)
		{
			if (Count == 1)
			{
				SendTo(buffer + 3, len - 3, false);
			}
			else
			{
				SendTo(buffer, len, false);
			}
		}
	}
	else if (TotalReliableClusters == Total)
	{
		// Ignore reliable attributes, prepend only one reliable header
		do
		{
			lp = parse->item;
			{
				// Make sure this message will fit
				DWORD thislen = lp->Length;

				if (thislen > 255)
				{
					// The message will not fit in a cluster, send the current cluster
					if (Count != 0)
					{
						if (Count == 1)
						{
							SendTo(buffer + 3, len - 3, true);
						}
						else
						{
							SendTo(buffer, len, true);
						}
						Count = 0;
					}

					// Send this message
					SendTo(lp->Message, thislen, true);
				}
				else if (len + thislen + 1 > 482)	// Don't chunk it
				{
					// The message will not fit, send the current cluster
					if (Count == 1)
					{
						SendTo(buffer + 3, len - 3, true);
					}
					else
					{
						SendTo(buffer, len, true);
					}

					// Start a new one with this message
					buffer[2] = thislen;
					memcpy(buffer + 3, lp->Message, thislen);
					len = 3 + thislen;
					Count = 1;
				}
				else
				{
					// The message will fit, concatenate it
					buffer[len] = thislen;
					memcpy(buffer + len + 1, lp->Message, thislen);
					len += (thislen + 1);
					Count++;
				}
			}
			parse = parse->next;

		} while (parse);

		// Send the cluster if there's anything in it
		if (Count != 0)
		{
			if (Count == 1)
			{
				SendTo(buffer + 3, len - 3, true);
			}
			else
			{
				SendTo(buffer, len, true);
			}
		}
	}
	else
	{
		// Group in order, add reliable headers manually
		do
		{
			lp = parse->item;
			{
				// Make sure this message will fit
				DWORD thislen = lp->Length;
				BYTE * thismsg;

				// Dump the reliable header into the mix
				if (lp->Reliable)
				{
					thislen += 6;
					thismsg = new BYTE[thislen];
					thismsg[0] = 0;
					thismsg[1] = 3;
					*(DWORD*)&thismsg[2] = LocalPost;
					memcpy(&thismsg[6], lp->Message, thislen - 6);

					if (Sendlog.Total < 3)
					{
						// Add unencrypted packet to the resend list
						Sendlog.Append(new PostlogNode(thismsg, thislen, LocalSend = LocalPost));
					}
					else
					{
						// Add encrypted packet to the message queue
						BYTE * splog = new BYTE[thislen];
						memcpy(splog, thismsg, thislen);
						Encrypt(splog, thislen);

						Postlog.Append(new PostlogNode(splog, thislen, LocalPost));

						delete splog;
					}

					// Set next ID
					LocalPost++;
				}
				else
				{
					thismsg = new BYTE[thislen];
					memcpy(thismsg, lp->Message, thislen);
				}

				if (thislen > 255)
				{
					// The message will not fit in a cluster, send the current cluster
					if (Count != 0)
					{
						if (Count == 1)
						{
							SendTo(buffer + 3, len - 3, false);
						}
						else
						{
							SendTo(buffer, len, false);
						}
						Count = 0;
					}

					// Send this message
					SendTo(thismsg, thislen, false);
				}
				else if (len + thislen + 1 > 482)	// Don't chunk it
				{
					// The message will not fit, send the current cluster
					if (Count == 1)
					{
						SendTo(buffer + 3, len - 3, false);
					}
					else
					{
						SendTo(buffer, len, false);
					}

					// Start a new one with this message
					buffer[2] = thislen;
					memcpy(buffer + 3, thismsg, thislen);
					len = 3 + thislen;
					Count = 1;
				}
				else
				{
					// The message will fit, concatenate it
					buffer[len] = thislen;
					memcpy(buffer + len + 1, thismsg, thislen);
					len += (thislen + 1);
					Count++;
				}
			}
			parse = parse->next;

		} while (parse);

		// Send the cluster if there's anything in it
		if (Count != 0)
		{
			if (Count == 1)
			{
				SendTo(buffer + 3, len - 3, false);
			}
			else
			{
				SendTo(buffer, len, false);
			}
		}
	}

	// Clean up
	Clustering = false;
	ClusterMessages.Clear(false);
}

void BotSession::Send(BYTE * Message, DWORD Length, bool Reliable)
{
	if (Clustering)
	{
		ClusterMessages.Append(new LoggedPacket(Message, Length, Reliable));
		if (Reliable) TotalReliableClusters++;
	}
	else
	{
		SendTo(Message, Length, Reliable);
	}
}

void BotSession::CheckPostlog(DWORD PacketID)
{
	if (PacketID == CloseID)
	{
		// This host was scheduled for disconnection
		Disconnect(false);
	}

	if (PacketID > LocalSend)
	{
		// Someone is toying with his source route!
		long IP = Remote.IP;
		short Port = htons(Remote.Port);
/*		printf("Malformed ACK from %i.%i.%i.%i:%i  Punt!\n",	(int)(((BYTE*)&IP)[0]),
																(int)(((BYTE*)&IP)[1]),
																(int)(((BYTE*)&IP)[2]),
																(int)(((BYTE*)&IP)[3]),
																Port);
*/
		Disconnect(false);

		return;
	}

	// Clear a SendLog entry
	_listnode <PostlogNode> * parse = Sendlog.head;

	while (parse)
	{
		if (parse->item->PacketID == PacketID)
		{
			// Update ping time
			if (Ping)
				Ping = (Ping + (GetTickCount() - parse->item->LastSend)) >> 1;
			else
				Ping = GetTickCount() - parse->item->LastSend;

			// Clear the entry
			Sendlog.Delete(parse, false);

			// Queue up another packet
			_listnode <PostlogNode> * pparse = Postlog.head;

			++LocalSend;

			while (pparse)
			{
				PostlogNode * post = pparse->item;

				if (post->PacketID == LocalSend)
				{
					// Send it if it is next
					sendto(SocketID, (char*)post->Message, post->Length, 0, (sockaddr*)&Remote, 16);
					TotalSent++;

					// Set 'ticks for last send
					post->SetTime();

					// Move it to the Sendlog
					Sendlog.Append(post);
					Postlog.Delete(pparse, true);

					return;
				}

				pparse = pparse->next;
			}

			return;
		}

		parse = parse->next;
	}
}


// SubGame->Client protocol implementation

void BotSession::PollFlagsForKickOff()
{
	_listnode <FlagData> * parse = FlagList.head;

	while (parse)
	{
		FlagData * flag = parse->item;
		parse = parse->next;

		if (GetTickCount() - flag->LastSend > 120000)
			FlagList.Delete(flag, false);
	}
}

FlagData * BotSession::FindFlag(SHORT ID)
{
	_listnode <FlagData> * parse = FlagList.head;

	while (parse)
	{
		FlagData * flag = parse->item;

		if (flag->FlagID == ID)
			return flag;

		parse = parse->next;
	}

	return NULL;
}

void BotSession::PollBallsForKickOff()
{
	_listnode <Powerball> * parse = SoccerList.head;

	while (parse)
	{
		Powerball * ball = parse->item;
		parse = parse->next;

		if (GetTickCount() - ball->LastSend > 5000)
			SoccerList.Delete(ball, false);
	}
}

Powerball * BotSession::FindPowerball(SHORT ID)
{
	_listnode <Powerball> * parse = SoccerList.head;

	while (parse)
	{
		Powerball * ball = parse->item;

		if (ball->BallID == ID)
			return ball;

		parse = parse->next;
	}

	return NULL;
}

void BotSession::SendPublicChat(const char * Message)
{
	BYTE ChatMessage[520];
	SHORT len = MakeChatMessage(ChatMessage, 2, 0, 0, Message);
	Send(ChatMessage, len, true);
}

void BotSession::SendPosition()
{
	if (Me)
	{
		// Send the position packet
		BYTE PositionUpdate[32];
		MakePosition(PositionUpdate,
					 Me->D = (Me->D + 1) % 40,
					 GetGameTime(),
					 (SHORT)Me->ty,
					 (SHORT)Me->y, 
					 MakePositionInfo(Me->bStealth, Me->bCloak, Me->bXRadar, Me->bAntiwarp, 0, 0, Me->bUFO, 0),
					 (SHORT)Me->x,
					 (SHORT)Me->tx,
					 (SHORT)Me->cBounty,
					 (SHORT)Me->cEnergy,
					 (Me->ShipType == 8) ? MakeWeaponInfo(PROJ_None, 0, 0, 0, 0, 0, 0, 0) : MakeWeaponInfo(PROJ_Bullet, Me->lGun - 1, 0, 0, 0, 0, 0, 0),
					 (SHORT)Ping,
					 0,
					 MakeItemInfo((Me->tShields != 0), (Me->tSuper != 0), Me->cBurst, Me->cRepel, Me->cPortal, Me->cDecoy, Me->cThor, Me->cBrick, Me->cRocket));
		Send(PositionUpdate, 22, false);

		if (Me->ShipType != 8)
			GenerateWeapon(Me, MakeWeaponInfo(PROJ_Bullet, Me->lGun - 1, 0, 0, 0, 0, 0, 0));
	}

	// Update state
	LastPositionUpdate = GetTickCount();
	PositionUpdateCount++;

	// Send Sync
	if (!(PositionUpdateCount % 40))
	{
		BYTE SyncPacket[14];
		MakeSyncRequest(SyncPacket, GetLocalTime(), TotalSent, TotalRecvd);
		Send(SyncPacket, 14, false);
	}
}

void BotSession::Connect(DWORD IP, SHORT Port)
{
	// Create a new host
	Remote.IP = IP;
	Remote.Port = htons(Port);

	BYTE EncryptRequest[8];
		MakeEncryptRequest(EncryptRequest, false);
		SentKey = GetLong(EncryptRequest, 2);

	Send(EncryptRequest, 8, false);
		Chat.AddMessage("Connecting...", CHAT_Grey);

	LastSessionSend = GetTickCount();
}


// Control

void BotSession::Initialize()
{
	// Kill old session
	if (hResend || hReceive || hGraphics)
		Terminate();

	ResetSession();

	INADDR sa(0, 0);

	SocketID = socket(2, 2, 0);

	strcpy(BotName, INISettings.Name);
	strcpy(BotPassword, INISettings.Pass);

	if (SocketID == SOCKET_ERROR)
	{
		_string S;
		S = "Unable to create socket: ";
		S += WSAGetErrorString(WSAGetLastError());
		MessageBox(NULL, S.Text, "BotSession::Initialize():", 0);
	}

	if (bind(SocketID, (sockaddr*)&sa, sizeof(sockaddr)) == SOCKET_ERROR)
	{
		_string S;
		S = "Unable to bind socket: ";
		S += WSAGetErrorString(GetLastError());
		MessageBox(NULL, S.Text, "BotSession::Initialize():", 0);
	}

	Connect(INISettings.IP, INISettings.Port);

	// Start threads
	unsigned long iThread;

	hGraphics	= CreateThread(NULL, 0, (unsigned long (__stdcall *)(void *))&CallGraphicsThread,	this, 0, &iThread);
	hResend		= CreateThread(NULL, 0, (unsigned long (__stdcall *)(void *))&CallResendThread,		this, 0, &iThread);
	hReceive	= CreateThread(NULL, 0, (unsigned long (__stdcall *)(void *))&CallRecvThread,		this, 0, &iThread);
}

void BotSession::Terminate()
{
	// Kill threads
	hResend = 0;
	hReceive = 0;
	hGraphics = 0;

	while (ThreadsOpen)
	{
		Sleep(10);
	}

	if (HasSession) Disconnect(true);

	// Unregister socket
	closesocket(SocketID);

	hResend = hGraphics = hReceive = 0;
}

bool BotSession::ValidateNewsChecksum(DWORD Checksum)
{
	_string s;

	for (int i = 0; i < 9999; i++)
	{
		s = "";
		if (i < 1000)
			s += "0";
		if (i < 100)
			s += "0";
		if (i < 10)
			s += "0";
		s += (int)i;
		DWORD Current = GetSettingDWORD(HKEY_CURRENT_USER, "Software\\Virgin\\SubSpace\\News", s.Text);

		if (Current == Checksum)
			return true;
	}

	return false;
}

void BotSession::AddNewsChecksum(DWORD Checksum)
{
	// Extract location to write the new checksum
	DWORD Position = GetSettingDWORD(HKEY_CURRENT_USER, "Software\\Virgin\\SubSpace\\News", "Pos");

	_string s;
	if (Position < 1000)
		s += "0";
	if (Position < 100)
		s += "0";
	if (Position < 10)
		s += "0";
	s += (int)Position;

	// Write the checksum
	SetSettingDWORD(HKEY_CURRENT_USER, "Software\\Virgin\\SubSpace\\News", s.Text, Checksum);

	// Calculate new location to write the next checksum
	Position++;
	if (Position == 10000)
		Position = 0;

	// Write this location to the registry
	SetSettingDWORD(HKEY_CURRENT_USER, "Software\\Virgin\\SubSpace\\News", "Pos", Position);
}

void BotSession::RetrieveSystemInformation()
{
	// Machine ID
	GetVolumeInformation("C:\\", NULL, 0, (DWORD*)&MachineID, NULL, NULL, NULL, 0);

	if (MachineID < 0)
		MachineID = -MachineID;
//		MachineID = ~MachineID + 1;		// Is this the right way to do it?

	// TimeZone Bias
	TIME_ZONE_INFORMATION tzi;
	GetTimeZoneInformation(&tzi);
	TZB = (SHORT)tzi.Bias;

	// Permission ID
	PermissionID = GetSettingDWORD(HKEY_LOCAL_MACHINE, "SOFTWARE", "D2");

	// Do some clean-up work for SubSpace
	if (PermissionID == 0)
	{
		LFSR_PRNG rnd;
		rnd.Seed(GetTickCount() ^ 0xAAAAAAAA);

		PermissionID = DWORD(rnd.GetNext() * 4294967295.0);

		SetSettingDWORD(HKEY_LOCAL_MACHINE, "SOFTWARE", "D2", PermissionID);
	}

	long D1 = GetSettingDWORD(HKEY_LOCAL_MACHINE, "SOFTWARE", "D1");

	if (D1 != MachineID)
	{
		SetSettingDWORD(HKEY_LOCAL_MACHINE, "SOFTWARE", "D1", MachineID);
	}

#ifdef USE_UNBANNER
	MachineID = GetTickCount() + 0xAAAAAAAA;
	PermissionID = GetTickCount() ^ 0xAAAAAAAA;
#endif
}


// Game physics implementation

void BotSession::GenerateWeapon(Player * player, WeaponInfo Type)
{
#ifdef LIMIT_WEAPONCOUNT
	if (WeaponList.Total + 1 >= 256)
		return;
#endif

	Weapon * weapon = new Weapon;

	weapon->Type = Type;
	weapon->DestroyTime = GetTickCount();
	weapon->SetBounce(1);
	weapon->Owner = player;

	switch (Type.Type)
	{
	case PROJ_Burst:
		{
			// Generate burst shrapnel instead
			WeaponInfo BurstBullet;
			BurstBullet.Type = PROJ_InactiveBullet;

			SHORT shrap	 = player->Settings->BurstShrapnel;
			LONG time	 = GetTickCount() + Settings.BulletAliveTime * 10;
			double speed = player->Settings->BurstSpeed;

			Weapon * burst;

#ifdef LIMIT_WEAPONCOUNT
	if (WeaponList.Total + shrap >= 256)
	{
		delete weapon;

		return;
	}
#endif

			for (int i = 0; i < shrap; i++)
			{
				burst = new Weapon;
				WeaponList.Append(burst);

				burst->DestroyTime = time;
				burst->Type = BurstBullet;
				burst->SetBounce(-1);
				burst->Owner = player;

				double bearing = (double)PI * 2.0 * (double)i / (double)shrap;

				burst->UpdatePosition(GetTickCount(), player->x, player->y, SHORT(speed * sin(bearing)), -SHORT(speed * cos(bearing)));
			}

			// Skip adding this entry entry
			delete weapon;
			return;
		}
	// Bullets are spawned under the nose
	case PROJ_BBullet:
			weapon->SetBounce(-1);
	case PROJ_Bullet:
		weapon->DestroyTime += Settings.BulletAliveTime * 10;

#ifdef LIMIT_WEAPONCOUNT
	if (WeaponList.Total + (Type.FireType ? 2 : 0)
						 + (player->Settings->DoubleBarrel ? 2 : 1) >= 256)
	{
		delete weapon;

		return;
	}
#endif

		if (Type.FireType)
		{
			// Multi fire
			double bearing = (double)PI * 2 * (double)player->D / (double)40.0;
			double speed = player->Settings->BulletSpeed;

			short px = player->x + short(10.0 * sin(bearing));
			short py = player->y - short(10.0 * cos(bearing));

			Weapon * shot1 = new Weapon;
			Weapon * shot2 = new Weapon;
			WeaponList.Append(shot1);
			WeaponList.Append(shot2);

			shot1->DestroyTime = weapon->DestroyTime;
			shot1->Type = Type;
			shot1->SetBounce(weapon->BounceCounter);
			shot1->Owner = player;

			shot2->DestroyTime = weapon->DestroyTime;
			shot2->Type = Type;
			shot2->SetBounce(weapon->BounceCounter);
			shot2->Owner = player;

			bearing = (double)PI * 2 * ((double)player->D - ((double)player->Settings->MultiFireAngle / (double)1000.0)) / (double)40.0;
			shot1->UpdatePosition(GetTickCount(), px, py, player->tx + short(speed * sin(bearing)), player->ty - short(speed * cos(bearing)));

			bearing = (double)PI * 2 * ((double)player->D + ((double)player->Settings->MultiFireAngle / (double)1000.0)) / (double)40.0;
			shot2->UpdatePosition(GetTickCount(), px, py, player->tx + short(speed * sin(bearing)), player->ty - short(speed * cos(bearing)));
		}

		if (player->Settings->DoubleBarrel)
		{
			// Double fire
			double bearing = (double)PI * 2 * (double)(player->D) / (double)40.0;
			double speed = player->Settings->BulletSpeed;

			Weapon * gun = new Weapon;
			gun->DestroyTime = weapon->DestroyTime;
			gun->Type = Type;
			gun->SetBounce(weapon->BounceCounter);
			gun->Owner = player;
			WeaponList.Append(gun);

			gun->UpdatePosition(GetTickCount(), player->x + short(10.0 * sin(bearing - 1)), player->y - short(10.0 * cos(bearing - 1)), player->tx + short(speed * sin(bearing)), player->ty - short(speed * cos(bearing)));
			weapon->UpdatePosition(GetTickCount(), player->x + short(10.0 * sin(bearing + 1)), player->y - short(10.0 * cos(bearing + 1)), player->tx + short(speed * sin(bearing)), player->ty - short(speed * cos(bearing)));
		}
		else
		{
			// Single fire
			double bearing = (double)PI * 2 * (double)player->D / (double)40.0;
			double speed = player->Settings->BulletSpeed;

			weapon->UpdatePosition(GetTickCount(), player->x + short(10.0 * sin(bearing)), player->y - short(10.0 * cos(bearing)), player->tx + short(speed * sin(bearing)), player->ty - short(speed * cos(bearing)));
		}

		break;
	case PROJ_Decoy:
		{
			weapon->SetBounce(-1);
			weapon->DestroyTime += Settings.DecoyAliveTime * 10;

			weapon->UpdatePosition(GetTickCount(), player->x, player->y, player->tx, player->ty);
		}
		break;			
	case PROJ_Repel:
		{
			weapon->DestroyTime += Settings.RepelTime * 10;
			weapon->SetBounce(-2);

			weapon->UpdatePosition(GetTickCount(), player->x, player->y, 0, 0);
		}
		break;			
	// Bombs are spawned under the nose
	case PROJ_Thor:
		weapon->SetBounce(-2);
	case PROJ_PBomb:
	case PROJ_Bomb:
		if (weapon->BounceCounter != -2)
		{
			if ((player->tx != 0) || (player->ty != 0))
			{
				weapon->SetBounce(player->Settings->BombBounceCount + 1);
			}
		}

		if (Type.FireType)
		{
			weapon->DestroyTime += Settings.MineAliveTime * 10;

			weapon->UpdatePosition(GetTickCount(), player->x, player->y, 0, 0);
		}
		else
		{
			weapon->DestroyTime += Settings.BombAliveTime * 10;

			double bearing = (double)PI * 2 * (double)player->D / (double)40.0;
			double speed = player->Settings->BombSpeed;
			weapon->UpdatePosition(GetTickCount(), player->x + short(10.0 * sin(bearing)), player->y - short(10.0 * cos(bearing)), player->tx + short(speed * sin(bearing)), player->ty - short(speed * cos(bearing)));
		}
		break;
	default:
		{
			//printf("WARNING: Unhandled weapon type ignored.\n");
		}
	}

	// Append the entry
	WeaponList.Append(weapon);
}

void BotSession::PollWeaponsForKickOff()
{
	_listnode <Weapon> * parse = WeaponList.head;

	while (parse)
	{
		Weapon * weapon = parse->item;
		parse = parse->next;

		if (GetTickCount() > weapon->DestroyTime)
		{
			WeaponList.Delete(weapon, false);
		}
	}
}

void BotSession::PollBricksForKickOff()
{
	_listnode <Brick> * parse = BrickList.head;

	while (parse)
	{
		Brick * brick = parse->item;
		parse = parse->next;

		if (GetTickCount() > brick->DestroyTime)
		{
			BrickList.Delete(brick, false);
		}
	}
}

DWORD BotSession::GetGameTime()
{
	return (GetTickCount() / 10 + DiffTime);
}

DWORD BotSession::GetLocalTime()
{
	return (GetTickCount() / 10);
}

DWORD BotSession::LocalToGameTime(DWORD LocalTime)
{
	return LocalTime + DiffTime;
}

DWORD BotSession::GameToLocalTime(DWORD GameTime)
{
	return GameTime - DiffTime;
}
