#define ERROR_TRAPPER

bool HandleInGameFlag		(PacketStruct * Packet)
{
	Packet->Source->SendingPosition = true;

	if (Packet->Source->INISettings.AccessLevel != ssPlayer)
	{
		_string staffpw;
		staffpw  = "*";
		staffpw += Packet->Source->INISettings.StaffPassword;
//		Packet->Source->SendPublicChat(staffpw.Text);	// Send staff password
	}

	return true;
}

bool HandleChat				(PacketStruct * Packet)
{
/* Error trapper */
#ifdef ERROR_TRAPPER

try
{

#endif
/* Error trapper */

	// Put chat handler here

	char * command = (char*)&Packet->Message[5];
	Player * player = Packet->Source->PlayerQAL.Get(Packet->Message[3]);

	_string s;

	switch (Packet->Message[1])
	{
	case MSG_Arena:
		s = "A:";
		break;
	case MSG_Unknown1:
		s = "1:";
		break;
	case MSG_Public:
		s = "P:";
		break;
	case MSG_Team:
		s = "T:";
		break;
	case MSG_TeamPrivate:
		s = "t:";
		break;
	case MSG_Private:
		s = "p:";
		break;
	case MSG_Unknown6:
		s = "6:";
		break;
	case MSG_RemotePrivate:
		s = "R:";
		break;
	case MSG_ServerError:
		s = "E:";
		break;
	case MSG_Channel:
		s = "C:";
		break;
	};

	if (player)
	{
		s += "[";
		s += player->Name;
		s += "] ";
	}
	else
	{
		s += "[";
		s += (int)GetShort(Packet->Message, 3);
		s += "] ";
	}

	s += command;

	Packet->Source->Chat.AddMessage(s.Text, CHAT_Green);

/* Error trapper */
#ifdef ERROR_TRAPPER

}
catch (...)		// catch any kind of error
{
	Packet->Source->Chat.AddMessage("Command crash attempt.", CHAT_Red);
}

#endif
/* Error trapper */

	return true;
}

bool HandleBannerAds		(PacketStruct * Packet)
{
	LONG fnFile = _open("banners.bin", _O_BINARY | _O_CREAT | _O_WRONLY, _S_IWRITE);
	_write(fnFile, Packet->Message + 1, Packet->Length - 1);
	_close(fnFile);

	Packet->Source->Chat.AddMessage("Got zone advertisements.  Wrote to disk as : banners.bin", CHAT_Grey);

	return true;
}

bool HandleCustomMessage	(PacketStruct * Packet)
{
	Packet->Source->Chat.AddMessage((char*)&Packet->Message[1], CHAT_Orange);

	return true;
}

bool HandleFileTransfer		(PacketStruct * Packet)
{
	// Extract filename
	char Filename[16];

	memcpy(Filename, &Packet->Message[1], 16);

	if (!(Packet->Message[1]))
		strcat(Filename, "news.txt");

	// Notify user of file
	_string s;
	s = "Received file: ";
	s += Filename;
	Packet->Source->Chat.AddMessage(s.Text, CHAT_Orange);

	// Uncompress file
	BYTE * CompressedFile = Packet->Message + 17;
	DWORD CompressedLength = Packet->Length - 17;

	BYTE * ResFile = NULL;
	DWORD ResLength	= (CompressedLength << 1),
		  status	= 0;

	do
	{
		if (ResFile)
			delete ResFile;

		ResLength += CompressedLength;
		ResFile = new BYTE[ResLength];

		status = uncompress(ResFile, &ResLength, CompressedFile, CompressedLength);

	} while (status == Z_BUF_ERROR);

	if (status)
	{
		MessageBox(NULL, "Damn uncompress()!!!", "Error:", 0);
		return true;
	}

	// Write uncompressed file
	LONG fnFile = _open((char*)&Filename[0], _O_BINARY | _O_CREAT | _O_WRONLY, _S_IWRITE);
	_write(fnFile, ResFile, ResLength);
	_close(fnFile);

	return true;
}

bool HandleMapRequest		(PacketStruct * Packet)		// Bad message type
{
	// Extract map names
	char * LocalMap = (char*)&Packet->Message[1];
	BYTE * RemoteMap = Packet->Message + 257;

	_string s;
	s = "Sending map file: ";
	s += LocalMap;

	Packet->Source->Chat.AddMessage(s.Text, CHAT_Green);

	// Open map for read
	LONG fnMap = _open(LocalMap, _O_BINARY, _O_RDONLY);

	if (fnMap == -1)
	{
		Packet->Source->Chat.AddMessage("Unable to open local map file.", CHAT_Red);

		return true;
	}

	// Read map length
	LONG FileLength = 0;
	GetFileLength(fnMap, FileLength);

	// Read map contents
	BYTE * MapContents = new BYTE[FileLength];
	_read(fnMap, MapContents, FileLength);
	_close(fnMap);

	// Compress the map data
	unsigned long CompressedMapLength = FileLength + (FileLength / 100) + 12;
	BYTE * CompressedMap = new BYTE[CompressedMapLength + 17];

	CompressedMap[0] = 22;
	memcpy(&CompressedMap[1], RemoteMap, 16);

	LONG RetVal = compress(CompressedMap + 17, &CompressedMapLength, MapContents, FileLength);

	if (RetVal != Z_OK)
	{
		Packet->Source->Chat.AddMessage("compress() returned with an error.", CHAT_Red);

		return true;
	}

	BYTE MapChunk[514];
	MapChunk[0] = 0;
	MapChunk[1] = 10;
	*(LONG*)&MapChunk[2] = CompressedMapLength;

	// Break up the map data and send it
	for (unsigned long Offset = 0; Offset < CompressedMapLength; Offset += 508)
	{
		SHORT Length;

		if (Offset + 508 < CompressedMapLength)
		{
			Length = 508;
		}
		else
		{
			Length = SHORT(CompressedMapLength - Offset);
			MapChunk[1] = 9;
		}

		memcpy(&MapChunk[6], &CompressedMap[Offset], Length);

		Packet->Source->Send(MapChunk, Length, true);
	}

	delete CompressedMap;

	s = "File sent: ";
	s += (char*)RemoteMap;

	Packet->Source->Chat.AddMessage(s.Text, CHAT_Green);

	return true;
}

bool HandleLoginUnknown		(PacketStruct * Packet)
{
	Packet->Source->Chat.AddMessage("Downloading game status...", CHAT_Grey);

	return true;
}

bool HandleIDChange			(PacketStruct * Packet)
{
	Packet->Source->MyID = Packet->Message[1];

	Player * player = Packet->Source->PlayerQAL.Get(Packet->Source->MyID);

	if (player)
		Packet->Source->Me = player;

	_string s;
	s = "Assigned PlayerID # ";
	s += Packet->Source->MyID;

	Packet->Source->Chat.AddMessage(s.Text, CHAT_Grey);

	return true;
}

bool HandleTurfFlagStatus	(PacketStruct * Packet)
{
	SHORT X;
	SHORT Y;
	BYTE FlagID = 0;

	// Update flag data
	for (DWORD i = 1; i < Packet->Length; i += 2, FlagID++)
	{
		SHORT Team = GetShort(Packet->Message, i);

		FlagData * flag = Packet->Source->FindFlag(FlagID);

		if (flag == NULL)
		{
			flag = new FlagData;
			Packet->Source->FlagList.Append(flag);
			flag->FlagID = FlagID;
		}

		flag->Carried = false;
		flag->Controller = NULL;
		flag->Team = Team;
		flag->LastSend = GetTickCount();

		if (Team)
		{
			_string s;
			s = "Flag # ";
			s += FlagID;
			s += " held by team ";
			s += Team;

			Packet->Source->Chat.AddMessage(s.Text, CHAT_Grey);
		}
		else
		{
			_string s;
			s = "Flag # ";
			s += FlagID;
			s += " is not held by any team";

			Packet->Source->Chat.AddMessage(s.Text, CHAT_Grey);
		}
	}

	// Extract X & Y coords from the map
	FlagID = 0;

	for (X = 0; X < 1024; X++)
	for (Y = 0; Y < 1024; Y++)
	{
		if (Packet->Source->Map[(X << 10) + Y] == 170)	//170 = Flag tile
		{
			FlagData * flag = Packet->Source->FindFlag(FlagID);

			if (flag)
			{
				flag->x = (X << 4);
				flag->y = (Y << 4);
			}

			FlagID++;
		}
	}

	return true;
}

bool HandlePrizePickup		(PacketStruct * Packet)
{
	DWORD TimeStamp	= (GetLong(Packet->Message, 1) - Packet->Source->DiffTime) * 10;
	Player * player = Packet->Source->PlayerQAL.Get((BYTE)GetShort(Packet->Message, 11));
	WORD PrizeType = GetShort(Packet->Message, 9);
	WORD x = GetShort(Packet->Message, 5);		// (in tiles)
	WORD y = GetShort(Packet->Message, 7);

	return true;
}

bool HandlePrize			(PacketStruct * Packet)
{
	SHORT PrizeCount	= GetShort(Packet->Message, 1);
	SHORT PrizeType		= GetShort(Packet->Message, 3);

	//printf("I greened: ");

	switch (PrizeType % 29)
	{
    case 0: //printf("Multiprize");	break;
    case 1: //printf("Recharge upgrade");	break;
    case 2: //printf("Energy upgrade");	break;
    case 3: //printf("Rotation upgrade");	break;
    case 4: //printf("Stealth upgrade");	break;
    case 5: //printf("Cloak upgrade");	break;
    case 6: //printf("XRadar upgrade");	break;
    case 7: //printf("Warp!");	break;
    case 8: //printf("Gun upgrade");	break;
    case 9: //printf("Bomb upgrade");	break;
    case 10: //printf("Bouncing bullets");	break;
    case 11: //printf("Thrust increase");	break;
    case 12: //printf("Top speed");	break;
    case 13: //printf("Full charge");	break;
    case 14: //printf("Engine shutdown");	break;
    case 15: //printf("Multifire");	break;
    case 16: //printf("Proximity");	break;
    case 17: //printf("Super!");	break;
    case 18: //printf("Shields!");	break;
    case 19: //printf("Shrapnel");	break;
    case 20: //printf("AntiWarp upgrade");	break;
    case 21: //printf("Repel");	break;
    case 22: //printf("Burst");	break;
    case 23: //printf("Decoy");	break;
    case 24: //printf("Thor");	break;
    case 25: //printf("Multiprize");	break;
    case 26: //printf("Brick");	break;
    case 27: //printf("Rocket");	break;
    case 28: //printf("Portal");	break;
    case -1: //printf("Slower recharge");	break;
    case -2: //printf("Less energy");	break;
    case -3: //printf("Slower rotation");	break;
    case -4: //printf("Lose stealth");	break;
    case -5: //printf("Lose cloak");	break;
    case -6: //printf("Lose Xradar");	break;
    case -7: //printf("Lose warp");	break;
    case -8: //printf("Gun downgrade");	break;
    case -9: //printf("Bomb downgrade");	break;
    case -10: //printf("Lose bouncing bullets");	break;
    case -11: //printf("Less thrust");	break;
    case -12: //printf("Lower top speed");	break;
    case -13: //printf("Energy depleted");	break;
    case -14: //printf("Engine shutdown");	break;
    case -15: //printf("Lose multifire");	break;
    case -16: //printf("Lose proximity");	break;
    case -17: //printf("Negative super!");	break;
    case -18: //printf("Negative shields!");	break;
    case -19: //printf("Lose shrapnel");	break;
    case -20: //printf("Lose antiwarp");	break;
    case -21: //printf("Lose repel");	break;
    case -22: //printf("Lose burst");	break;
    case -23: //printf("Lose decoy");	break;
    case -24: //printf("Lose thor");	break;
    case -25: //printf("Negative multiprize");	break;
    case -26: //printf("Lose brick");	break;
    case -27: //printf("Lose rocket");	break;
    case -28: //printf("Lose portal");	break;
		break;
	};

	if (PrizeCount == 1)
	{
		//printf(" 1 time.\n");
	}
	else
	{
		//printf(" %i times.\n", PrizeCount);
	}

	return true;
}

bool HandlePlayerEntering	(PacketStruct * Packet)
{
	for (DWORD Offset = 1; Offset < Packet->Length; Offset += 64)
	{
		/* Offset	Length		Description
		 * 0		1			Ship type, 0-8
		 * 1		1			? boolean flag
		 * 2		20			Player name
		 * 22		20			Player squad name
		 * 42		4			Points # 1
		 * 46		4			Points # 2
		 * 50		2			Player ID (only one byte perhaps?)
		 * 52		2			Frequency
		 * 54		2			Wins
		 * 56		2			Losses
		 * 58		1			? (0 - 5) generally 0
		 * 59		1			? default 255
		 * 60		1			? default 255
		 * 61		1			? default 0
		 * 62		1			Effect? (const 0)
		 */

		char * PlayerName = (char*)&Packet->Message[Offset + 2];

		Packet->Source->AddPlayer(Packet->Message[Offset + 50],
								  Packet->Message[Offset],
								  PlayerName,
								  (char*)&Packet->Message[Offset + 22],
								  GetLong(Packet->Message, Offset + 42),
								  GetLong(Packet->Message, Offset + 46),
								  GetShort(Packet->Message, Offset + 52),
								  GetShort(Packet->Message, Offset + 54),
								  GetShort(Packet->Message, Offset + 56));

		_string s;
		s = "Player entering arena: ";
		s += PlayerName;
		if (Packet->Message[58])
		{
			s += "(58 : ";
			s += (int) Packet->Message[58];
			s += ")";
		}
		if (Packet->Message[59] != 255)
		{
			s += "(59 : ";
			s += (int) Packet->Message[59];
			s += ")";
		}
		if (Packet->Message[60] != 255)
		{
			s += "(60 : ";
			s += (int) Packet->Message[60];
			s += ")";
		}
		if (Packet->Message[61])
		{
			s += "(61 : ";
			s += (int) Packet->Message[61];
			s += ")";
		}
		Packet->Source->Chat.AddMessage(s.Text, CHAT_Orange);
	}

	return true;
}

bool HandleSetFreq			(PacketStruct * Packet)
{
	Player * player = Packet->Source->PlayerQAL.Get(Packet->Message[1]);

	if (player)
	{
		player->Frequency	= GetShort(Packet->Message, 3);

		//printf("%s changed to team # %i.\n", player->Name, player->Frequency);
	}

	return true;
}

bool HandleSetFreqAndShip	(PacketStruct * Packet)
{
	Player * player = Packet->Source->PlayerQAL.Get(Packet->Message[2]);

	if (player)
	{
		player->ShipType	= Packet->Message[1];
		player->Frequency	= GetShort(Packet->Message, 4);

		//printf("%s changed to team # %i, ship # %i.\n", player->Name, player->Frequency, player->ShipType);
	}

	return true;
}

bool HandlePlayerBanner		(PacketStruct * Packet)
{
	Player * player = Packet->Source->PlayerQAL.Get(Packet->Message[1]);

	if (player)
	{
		memcpy(player->Banner, &Packet->Message[3], 96);

		//printf("Got %s's banner.\n", player->Name);
	}

	return true;
}

bool HandlePlayerLeaving	(PacketStruct * Packet)
{
	Player * player = Packet->Source->PlayerQAL.Get(Packet->Message[1]);

	if (player)
	{
		_string s;
		s = "Player leaving arena: ";
		s += player->Name;
		Packet->Source->Chat.AddMessage(s.Text, CHAT_Orange);
	}

	Packet->Source->NukePlayer(Packet->Message[1]);

	return true;
}

bool HandleTurretPlayer		(PacketStruct * Packet)
{
	BYTE Turreter = Packet->Message[1];
	BYTE Turretee = Packet->Message[3];

	Player * turreter = Packet->Source->PlayerQAL.Get(Turreter);

	if (turreter)
	{
		if (Turretee == 255)
		{
			turreter->AttachedTo = NULL;
		}
		else
		{
			Player * turretee = Packet->Source->PlayerQAL.Get(Turretee);

			if (turretee)
			{
				turreter->AttachedTo = turretee;
			}
		}
	}

	return true;
}

bool HandleUnturret			(PacketStruct * Packet)
{
	BYTE Turreter = Packet->Message[1];

	Player * turreter = Packet->Source->PlayerQAL.Get(Turreter);

	if (turreter)
		turreter->AttachedTo = NULL;

	return true;
}

bool HandleBallPosition		(PacketStruct * Packet)
{
	BYTE OwnerID = Packet->Message[10];
	BYTE BallID = Packet->Message[1];
	SHORT X = GetShort(Packet->Message, 2);
	SHORT Y = GetShort(Packet->Message, 4);
	SHORT ThrustX = GetShort(Packet->Message, 6);
	SHORT ThrustY = GetShort(Packet->Message, 8);
	DWORD TimeStamp = GetLong(Packet->Message, 12);

	Powerball * ball = Packet->Source->FindPowerball(BallID);

	if (ball == NULL)
	{
		ball = new Powerball;
		ball->BallID = BallID;
		Packet->Source->SoccerList.Append(ball);
	}

	ball->LastSend = GetTickCount();

	if ((TimeStamp == 0) || (ball->TimeStamp != TimeStamp))	// Ignore it if the tarjectory hasn't changed.
	{
		ball->TimeStamp = TimeStamp;

		ball->SetBounce(-1);
		if (TimeStamp) ball->UpdatePosition((TimeStamp - Packet->Source->DiffTime) * 10, X, Y, ThrustX, ThrustY);

		Player * player = Packet->Source->PlayerQAL.Get(OwnerID);

		ball->Controller = player;

		if (TimeStamp)
		{
			// Player is not carrying it
			ball->Carried = false;

			//printf("Uncontrolled powerball # %i @ (%i %i)\n", BallID, X, Y);
		}
		else
		{
			// Player is carrying it
			ball->Carried = true;

			if (player)
			{
				ball->SetFriction(Packet->Source->Settings.ships[player->ShipType].SoccerBallFriction);
				//printf("%s has powerball # %i @ (%i %i)\n", player->Name, BallID, X, Y);
			}
		}
	}

	return true;
}

bool HandleArenaList		(PacketStruct * Packet)
{
	DWORD i = 0;

	//printf("Arena list:\n");

	while (i < Packet->Length)
	{
		char * command	= (char*)&Packet->Message[i];
		SHORT Length	= strlen(command),
			  Total		= GetShort(command, Length + 1);
		i += Length + 2;

		_string s;
		s = command;
		s += "(";
		s += Total;
		s += ")";
		Packet->Source->Chat.AddMessage(s.Text, CHAT_Purple);
	}

	return true;
}

bool HandleFlagVictory		(PacketStruct * Packet)
{
	SHORT Team	 = GetShort(Packet->Message, 1);
	LONG Points = GetLong(Packet->Message, 3);

	Packet->Source->FlagList.Clear(false);

	if (Team == -1)
	{
		// Flag game reset
		//printf("Flag game reset.\n");
	}
	else
	{
		// Team victory
		//printf("Team # %i won the flag game for %i points.\n", Team, Points);

		_listnode <Player> * parse = Packet->Source->PlayerList.head;

		while (parse)
		{
			Player * player = parse->item;
			parse = parse->next;

			if (player->Frequency == Team)
				player->FlagPoints += Points;
		}
	}

	return true;
}

bool HandleScoreReset			(PacketStruct * Packet)
{
	SHORT PlayerID = GetShort(Packet->Message, 1);

	//printf("Player # %i lost his score.\n", PlayerID);

	_listnode <Player> * parse = Packet->Source->PlayerList.head;

	while (parse)
	{
		Player * player = parse->item;
		parse = parse->next;

		if ((player->PlayerID == PlayerID) || (PlayerID == -1))
		{
			player->FlagPoints = 0;
			player->KillPoints = 0;
			player->Wins = 0;
			player->Losses = 0;
		}
	}

	return true;
}

bool HandleFlagDrop			(PacketStruct * Packet)
{
	BYTE PlayerID = Packet->Message[1];

	Player * player = Packet->Source->PlayerQAL.Get(PlayerID);

	_listnode <FlagData> * parse = Packet->Source->FlagList.head;

	while (parse)
	{
		FlagData * flag = parse->item;
		parse = parse->next;

		if (flag->Controller == player)
		{
			flag->Controller = NULL;
			flag->Carried = false;
			flag->LastSend = GetTickCount();
		}
	}

	return true;
}

bool HandleFlagClaim		(PacketStruct * Packet)
{
	SHORT FlagID = GetShort(Packet->Message, 1);
	BYTE PlayerID = Packet->Message[3];

	Player * player = Packet->Source->PlayerQAL.Get(PlayerID);

	FlagData * flag = Packet->Source->FindFlag(FlagID);

	if (flag == NULL)
	{
		flag = new FlagData;
		Packet->Source->FlagList.Append(flag);
		flag->FlagID = FlagID;
	}

	if (Packet->Source->Settings.CarryFlags)
	{
		flag->Controller = player;
		flag->Carried = true;
	}

	flag->LastSend = GetTickCount();

	return true;
}

bool HandleFlagReward		(PacketStruct * Packet)
{
	DWORD Offset = 1;

	while (Packet->Length > Offset)
	{
		SHORT Team	 = GetShort(Packet->Message, Offset);
		SHORT Points = GetShort(Packet->Message, Offset + 2);

		//printf("Team # %i got a flag reward of %i points. (%i)\n", Team, Points, Packet->Length);

		_listnode <Player> * parse = Packet->Source->PlayerList.head;

		while (parse)
		{
			Player * player = parse->item;
			parse = parse->next;

			if (player->Frequency == Team)
				player->FlagPoints += Points;
		}

		Offset += 4;
	}

	return true;
}

bool HandlePlayerPosition	(PacketStruct * Packet)
{
	BYTE D			= Packet->Message[1];
	DWORD TimeStamp	= ((((Packet->Source->GetGameTime()) & 0xFFFF0000) | ((WORD)GetShort(Packet->Message, 2) & 0x0000FFFF)) - Packet->Source->DiffTime) * 10;
	SHORT X			= abs(GetShort(Packet->Message, 4));
	BYTE PlayerID	= Packet->Message[8];
	SHORT ThrustY	= GetShort(Packet->Message, 10);
	SHORT Y			= abs(GetShort(Packet->Message, 12));
	SHORT ThrustX	= GetShort(Packet->Message, 14);
	SHORT Energy	= GetShort(Packet->Message, 16);

	Player * player = Packet->Source->PlayerQAL.Get(PlayerID);

	if (player)
	{
		player->UpdatePosition(TimeStamp, X, Y, ThrustX, ThrustY);
		player->D		= D;
		player->cEnergy	= Energy;
	}

	return true;
}

bool HandleKoTHReset		(PacketStruct * Packet)
{
	char PlayerID = Packet->Message[6];

	// Clear personal KoTH status
	BYTE KoTHReset[1];
	MakeKoTHReset(KoTHReset);
	Packet->Source->Send(KoTHReset, 1, true);

	if (PlayerID == -1)
	{
		Packet->Source->Chat.AddMessage("King of the Hill restarted", CHAT_Green);
	}
	else
	{
		Player * player = Packet->Source->PlayerQAL.Get((BYTE)PlayerID);

		if (player)
		{
			player->tKing = 0;
		}
		else
		{
			Packet->Source->Chat.AddMessage("King of the Hill restarted(?)", CHAT_Green);
		}
	}

	return true;
}

bool HandleShipReset		(PacketStruct * Packet)
{
	//printf("Bot ship reset.\n");

	BYTE DropPacket[1];
	MakeDropAllFlags(DropPacket);
	Packet->Source->Send(DropPacket, 1, true);

	return true;
}

bool HandleArenaSettings	(PacketStruct * Packet)
{
	Packet->Source->Chat.AddMessage("Got arena settings.  Re-initializing configuration...", CHAT_Grey);
/*
	if (Packet->Source->Settings.ident == 15)
	{
		BYTE * old_settings = Packet->Source->arena_settings;
		BYTE * new_settings = Packet->Message;

		Packet->Source->SendPublicChat("Searching new settings for differences...");

		for (int i = 0; i < 1428; i++)
		{
			if (new_settings[i] != old_settings[i])
			{
				_string s;
				s  = "Settings change @ ";
				s += i;
				s += " - from ";
				s += old_settings[i];
				s += "[";
				for (int o = 0; o < 8; o++)
				{
					if (old_settings[i] & (1 << o))
						s += "1";
					else
						s += "0";
				}
				s += "] to ";
				s += new_settings[i];
				s += "[";
				for (o = 0; o < 8; o++)
				{
					if (new_settings[i] & (1 << o))
						s += "1";
					else
						s += "0";
				}
				s += "]";

				Packet->Source->SendPublicChat(s.Text);
			}
		}

		Packet->Source->SendPublicChat("...Done.");
	}
*/
	memcpy(&Packet->Source->Settings, Packet->Message, 1428);
//	memcpy(Packet->Source->arena_settings, Packet->Message, 1428);
/*
	_string s;
	s = "RandomShrapnel : ";
	s += (int)Packet->Source->Settings.RandomShrapnel;
	Packet->Source->SendPublicChat(s.Text);
	s = "ClientSlowPacketSampleSize : ";
	s += (int)Packet->Source->Settings.ClientSlowPacketSampleSize;
	Packet->Source->SendPublicChat(s.Text);
*/
	return true;
}

bool HandleStatusUnknown	(PacketStruct * Packet)
{
	LONG fnFile = _open("status50.bin", _O_BINARY | _O_CREAT | _O_WRONLY, _S_IWRITE);
	_write(fnFile, Packet->Message + 1, Packet->Length - 1);
	_close(fnFile);

	_string s;
	s = "Got wierd player status packet.  (";
	s += (int) GetShort(Packet->Message, 1);
	s += ")(";
	s += (int) GetShort(Packet->Message, 3);
	s += ")";
	Packet->Source->Chat.AddMessage(s.Text, CHAT_Orange);

	return true;
}

bool HandleToggleUFO		(PacketStruct * Packet)
{
	Player * me = Packet->Source->Me;

	if (me)
	{
		if (Packet->Message[1])
		{
			me->bUFO = false;
			me->hUFO = true;
			Packet->Source->Chat.AddMessage("UFO available: On", CHAT_Green);
		}
		else
		{
			me->bUFO = false;
			me->hUFO = false;
			Packet->Source->Chat.AddMessage("UFO available: Off", CHAT_Green);
		}
	}

	return true;
}

bool HandleDoorToggle		(PacketStruct * Packet)
{
	if (Packet->Length == 1)
	{
		//printf("Doors changed state.\n");
	}
	else if (Packet->Length == 17)
	{
		/* Offset	Length		Description
		 * 0		1			Type byte
		 * 1		2			X1
		 * 3		2			Y1
		 * 5		2			X2
		 * 7		2			Y2
		 * 9		2			Team
		 * 11		2			BrickID
		 * 13		4			Time stamp
		 */

		long x1 = GetShort(Packet->Message, 1);
		long y1 = GetShort(Packet->Message, 3);
		long x2 = GetShort(Packet->Message, 5);
		long y2 = GetShort(Packet->Message, 7);

		SHORT Team		= GetShort(Packet->Message, 9);
		SHORT BrickID	= GetShort(Packet->Message, 11);

		// Trace brick blocks
		long mx = SGN(x2 - x1);
		long my = SGN(y2 - y1);

		long x = x1, y = y1;

		if (mx)
		{
			while (x != x2)
			{
				x += mx;

				Brick * brick = new Brick;
				Packet->Source->BrickList.Append(brick);

				brick->DestroyTime = GetTickCount() + (Packet->Source->Settings.BrickTime * 10);
				brick->Team = Team;
				brick->x = (x << 4);
				brick->y = (y << 4);
			}
		}
		else
		{
			while (y != y2)
			{
				y += my;

				Brick * brick = new Brick;
				Packet->Source->BrickList.Append(brick);

				brick->DestroyTime = GetTickCount() + (Packet->Source->Settings.BrickTime * 10);
				brick->Team = Team;
				brick->x = (x << 4);
				brick->y = (y << 4);
			}
		}
	}
	else
	{
		//printf("Tiles changed state:\n");
		Packet->Dump();
	}

	return true;
}

bool HandleMapInformation	(PacketStruct * Packet)
{
	char Filename[16];
					memcpy(Filename, &Packet->Message[1], 16);
	LONG Checksum = GetLong(Packet->Message, 17);

	//printf("Loading map file: %s(%i)", Filename, Checksum);

	if (Packet->Source->LoadMap(Filename, Checksum))
	{
		// Map loaded okay
		//printf(" - Load complete.\n");
	}
	else
	{
		// Map must be requested
		BYTE MapRequest[1];
		MakeMapfileRequest(MapRequest);
		Packet->Source->Send(MapRequest, 1, true);

		Packet->Source->Chat.AddMessage("Downloading map file...", CHAT_Grey);

		//printf(" - Downloading it...\n");
	}

	return true;
}

bool HandleMapFile			(PacketStruct * Packet)
{
	Packet->Source->Chat.AddMessage("Opening map file...", CHAT_Grey);

	Packet->Source->SaveMap(&Packet->Message[1], &Packet->Message[17], Packet->Length - 17);

	Packet->Source->Chat.AddMessage("Loading complete.", CHAT_Grey);

	return true;
}

bool HandleKeepAlive		(PacketStruct * Packet)
{
	//printf("Ping? Pong!\n");

	return true;
}

bool HandleSpecPlayer		(PacketStruct * Packet)
{
	Player * player = Packet->Source->PlayerQAL.Get(Packet->Message[2]);

	if (player)
	{
		//printf("%s spectated.\n", player->Name);
	}

	return true;
}

bool HandleFlagPosition		(PacketStruct * Packet)
{
	SHORT FlagID	= GetShort(Packet->Message, 1);
	SHORT X			= GetShort(Packet->Message, 3);
	SHORT Y			= GetShort(Packet->Message, 5);
	BYTE Carrier	= Packet->Message[7];

	FlagData * flag = Packet->Source->FindFlag(FlagID);

	if (flag == NULL)
	{
		flag = new FlagData;
		Packet->Source->FlagList.Append(flag);
		flag->FlagID = FlagID;
	}

	Player * player = Packet->Source->PlayerQAL.Get(Carrier);

	if (player)
	{
		flag->Controller = player;
		flag->Carried = true;
		flag->Team = player->Frequency;
		//printf("Flag # %i @ (%i,%i) held by %s\n", FlagID, X, Y, player->Name);
	}
	else
	{
		flag->Controller = NULL;
		flag->Carried = false;
		//printf("Flag # %i @ (%i,%i)\n", FlagID, X, Y);
	}

	flag->x = (X << 4);
	flag->y = (Y << 4);
	flag->LastSend = GetTickCount();

	return true;
}

bool HandleSecurityChecksum	(PacketStruct * Packet)
{
	LONG Key = GetLong(Packet->Message, 13);

	if (Key)
	{
		LONG ParamChecksum	= GenerateParameterChecksum(Key, (LONG*)&Packet->Source->Settings);
		LONG EXEChecksum	= GenerateEXEChecksum(Key);
		LONG LevelChecksum	= GenerateLevelChecksum(Key, (char*)Packet->Source->ChecksumMap);

		Packet->Source->S2CSlowTotal += Packet->Source->S2CSlowCurrent;
		Packet->Source->S2CFastTotal += Packet->Source->S2CFastCurrent;

		BYTE SecurityChecksum[40];
		MakeSecurityChecksum(SecurityChecksum, ParamChecksum, EXEChecksum, LevelChecksum,
							 Packet->Source->LastPing, Packet->Source->AveragePing,
							 Packet->Source->LowestPing, Packet->Source->HighestPing,
							 Packet->Source->WeaponCount, Packet->Source->S2CSlowCurrent,
							 Packet->Source->S2CFastCurrent, Packet->Source->S2CSlowTotal,
							 Packet->Source->S2CFastTotal, false);
		Packet->Source->Send(SecurityChecksum, 40, true);

		Packet->Source->S2CSlowCurrent = 0;
		Packet->Source->S2CFastCurrent = 0;
	}

	return true;
}

bool HandleSoccerGoal		(PacketStruct * Packet)
{
	SHORT Team	= GetShort(Packet->Message, 1);
	LONG Points = GetLong(Packet->Message, 3);

	//printf("Team # %i scored a goal for %i points.\n", Team, Points);

	_listnode <Player> * parse = Packet->Source->PlayerList.head;

	while (parse)
	{
		Player * player = parse->item;
		parse = parse->next;

		if (player->Frequency == Team)
			player->FlagPoints += Points;
	}

	return true;
}

bool HandleScoreUpdate		(PacketStruct * Packet)
{
	LONG FlagPoints = GetLong(Packet->Message, 3);
	LONG KillPoints = GetLong(Packet->Message, 7);
	SHORT Wins		= GetShort(Packet->Message, 11);
	SHORT Losses	= GetShort(Packet->Message, 13);

	Player * player = Packet->Source->PlayerQAL.Get(Packet->Message[1]);

	if (player)
	{
		//printf("%s's new score : %i pts %i / %i\n", player->Name, FlagPoints + KillPoints, Wins, Losses);
	}

	return true;
}

bool HandleWeaponsFire		(PacketStruct * Packet)
{
	/* Offset	Length		Description
	 * 0		1			Type byte
	 * 1		1			Rotation
	 * 2		2			Time stamp
	 * 4		2			X
	 * 6		2			Y-thrust
	 * 8		1			PlayerID
	 * 9		1			Effect
	 * 10		2			X-Thrust
	 * 12		1			Checksum
	 * 13		1			Togglables
	 * 14		1			Ping
	 * 15		2			Y
	 * 17		2			Bounty
	 * 19		1			Weapon params
	 * 20		1			Weapon type
	 * ------------------------------ When *energy is enabled:
	 * 21		2			Energy
	 */

	BYTE PlayerID = Packet->Message[8];

	if (Packet->Source->Me && (PlayerID == Packet->Source->Me->PlayerID))
	{
		Packet->Source->Chat.AddMessage("WARNING: Server attempted to set location.  Packet stored as POSpos.bin", CHAT_Orange);

		LONG fnFile = _open("POSpos.bin", _O_BINARY | _O_CREAT | _O_WRONLY, _S_IWRITE);
		_write(fnFile, Packet->Message, Packet->Length);
		_close(fnFile);

		//return true;
	}

	BYTE Direction	= Packet->Message[1];
	DWORD TimeStamp	= ((((Packet->Source->GetGameTime()) & 0xFFFF0000) | ((WORD)GetShort(Packet->Message, 2) & 0x0000FFFF)) - Packet->Source->DiffTime) * 10;
	SHORT X			= abs(GetShort(Packet->Message, 4));
	SHORT ThrustY	= GetShort(Packet->Message, 6);
	BYTE Effect		= Packet->Message[9];
	SHORT ThrustX	= GetShort(Packet->Message, 10);
	BYTE Checksum	= Packet->Message[12];
	BYTE Ping		= Packet->Message[14];
	SHORT Y			= abs(GetShort(Packet->Message, 15));
	SHORT Bounty	= GetShort(Packet->Message, 17);

	PositionInfo Togglables;
	BYTE Offset13 = Packet->Message[13];
	memcpy(&Togglables, &Offset13, 1);

	WeaponInfo Weapon;
	SHORT Offset19 = GetShort(Packet->Message, 19);
	memcpy(&Weapon, &Offset19, 2);

	Player * player = Packet->Source->PlayerQAL.Get(PlayerID);

	if (player)
	{
		// Update player information if necessary
//		if (player->LastUpdateTime < TimeStamp)
		{
			player->UpdatePosition(TimeStamp, X, Y, ThrustX, ThrustY);
		}

		player->cBounty = Bounty;
		player->bAntiwarp = Togglables.Antiwarp;
		player->bCloak = Togglables.Cloaked;
		player->bStealth= Togglables.Stealth;
		player->bUFO = Togglables.UFO;
		player->bXRadar = Togglables.XRadar;
		player->D = Direction;
		player->Ping = Ping;
		if (Packet->Length > 22)
			player->cEnergy = (WORD)GetShort(Packet->Message, 21);

		// Generate a projectile from the weapon data
		if (Weapon.Type)
		{
			// Use settings to complete weapon data
			if (Weapon.EMP)
				Weapon.EMP = Packet->Source->Settings.ships[player->ShipType].EmpBomb;

			if (Weapon.Bouncing)
				Weapon.Bouncing = (Packet->Source->Settings.ships[player->ShipType].BombBounceCount ? 1 : 0);

			Packet->Source->GenerateWeapon(player, Weapon);
			Packet->Source->WeaponCount++;
		}
	}

	return true;
}

bool HandlePlayerDeath		(PacketStruct * Packet)
{
	BYTE Killee		= Packet->Message[4];
	BYTE Killer		= Packet->Message[2];
	SHORT Bounty	= GetShort(Packet->Message, 6);

	Player * killee = Packet->Source->PlayerQAL.Get(Killee);
	Player * killer = Packet->Source->PlayerQAL.Get(Killer);

	if (killer && killee)
	{
		_string s;
		s = killee->Name;
		s += "(";
		s += Bounty;
		s += ") was killed by: ";
		s += killer->Name;
		Packet->Source->Chat.AddMessage(s.Text, CHAT_Green);

		killee->x = 0;
		killee->y = 0;
		killee->tx = 0;
		killee->ty = 0;
	}

	return true;
}

bool HandlePasswordAccept	(PacketStruct * Packet)
{
	// Validate packet timing
	if (Packet->Source->PasswordWait == false)
	{
		Packet->Source->Chat.AddMessage("WARNING: Unsolicited password packet ignored.", CHAT_Red);

		LONG fnFile = _open("unsolicited.bin", _O_BINARY | _O_CREAT | _O_WRONLY, _S_IWRITE);
		_write(fnFile, Packet->Message, Packet->Length);
		_close(fnFile);

		return true;
	}
	else
	{
		LONG fnFile = _open("solicited.bin", _O_BINARY | _O_CREAT | _O_WRONLY, _S_IWRITE);
		_write(fnFile, Packet->Message, Packet->Length);
		_close(fnFile);
	}

	Packet->Source->PasswordWait = false;

	// Extract a few useful bits of information
	DWORD NewsChecksum = GetLong(Packet->Message, 24);
	BYTE Meaning = Packet->Message[1];
	BYTE RequestRegistrationForm = Packet->Message[19];

	//Check registration form
	if (RequestRegistrationForm)
	{
		BYTE RegForm[768];
		MakeRegFormResponse(RegForm, "Ave-iator", "Ave@ave.net", "AvePlace", "AveState", true, 17, true, true, true, 586, 0x4307F4C1, 0x64697462);
		Packet->Source->Send(RegForm, 768, true);

		Packet->Source->Chat.AddMessage("Sent registration form.", CHAT_Grey);
	}

	// Check meaning of password response
	switch (Meaning)
	{
	case NO_SCORES:
		Packet->Source->Chat.AddMessage("Dataserver offline: Scores are not saved in this zone.", CHAT_Green);
	case NO_PROBLEMO:
		Packet->Source->Chat.AddMessage("Password packet acccepted.", CHAT_Green);

		// Check if we have the news.txt file for this zone
		if (Packet->Source->ValidateNewsChecksum(NewsChecksum) == false)
		{
			Packet->Source->AddNewsChecksum(NewsChecksum);
			Packet->Source->Chat.AddMessage("Downloading zone news...", CHAT_Grey);

			BYTE NewsRequest[1];
			MakeNewsfileRequest(NewsRequest);
			Packet->Source->Send(NewsRequest, 1, true);
		}

		BYTE ArenaPacket[26];
		MakeArenaLogin(ArenaPacket, Packet->Source->INISettings.ShipType, Packet->Source->INISettings.Arena, 1600, 1280);
		Packet->Source->Send(ArenaPacket, 26, true);
		break;
	case NEW_USER:
		Packet->Source->Chat.AddMessage("New user.  Continuing...", CHAT_Yellow);
		{
			BYTE LoginPacket[101];
			MakeLogin(LoginPacket, Packet->Source->BotName, Packet->Source->BotPassword, Packet->Source->MachineID, Packet->Source->TZB, Packet->Source->PermissionID, true, 0);
			Packet->Source->Send(LoginPacket, 101, true);

			Packet->Source->PasswordWait = true;
		}
		break;
	case SERVER_BUSY:
		Packet->Source->Chat.AddMessage("Server busy.  Retrying...", CHAT_Yellow);
		{
			BYTE LoginPacket[101];
			MakeLogin(LoginPacket, Packet->Source->BotName, Packet->Source->BotPassword, Packet->Source->MachineID, Packet->Source->TZB, Packet->Source->PermissionID, false, 0);
			Packet->Source->Send(LoginPacket, 101, true);

			Packet->Source->PasswordWait = true;
		}
		break;
	case BAD_PW:
		Packet->Source->Chat.AddMessage("Blocked: Bad password.", CHAT_Orange);
		break;
	case IP_BLOCK:
		Packet->Source->Chat.AddMessage("Blocked: Host", CHAT_Red);
		break;
	case ID_BLOCK:
		Packet->Source->Chat.AddMessage("Blocked: Machine or Host (range)", CHAT_Red);
		break;
	case PERMISSION_ZONE:
		Packet->Source->Chat.AddMessage("Blocked: Machine or Permission", CHAT_Red);
		break;
	case INVALID_NAME:
		Packet->Source->Chat.AddMessage("Blocked: Invalid name", CHAT_Red);
		break;
	case OBSCENE_NAME:
		Packet->Source->Chat.AddMessage("Blocked: Obscene name", CHAT_Red);
		break;
	case NAME_MISSING:
		Packet->Source->Chat.AddMessage("Blocked: Missing name", CHAT_Red);
		break;
	case ADVANCED_ONLY:
		Packet->Source->Chat.AddMessage("Blocked: Not enough logged hours to play.", CHAT_Orange);
		break;
	};

	return true;
}
