#ifndef RPC_H
#define RPC_H
#endif


// Handlers

bool HandleUnknownSpecial	(PacketStruct * Packet)
{
//	printf("Unhandled special packet(%i)\n", (int)Packet->Message[1]);

	return true;
}

bool HandleEncryptRequest	(PacketStruct * Packet)
{
	if ((Packet->Length != 8) || GetLong(Packet->Message, 2) == 0)
	{
		// Display connection request
		long IP = Packet->Source->Remote.IP;
		short Port = htons(Packet->Source->Remote.Port);
/*		printf("Malformed connection request from %i.%i.%i.%i  Punt!\n",	(int)(((BYTE*)&IP)[0]),
																			(int)(((BYTE*)&IP)[1]),
																			(int)(((BYTE*)&IP)[2]),
																			(int)(((BYTE*)&IP)[3]),
																			Port);
*/
		Packet->Source->Disconnect(false);

		return true;
	}
	else
	{
		// Display connection request
		long IP = Packet->Source->Remote.IP;
		short Port = htons(Packet->Source->Remote.Port);
/*		printf("Connection request from %i.%i.%i.%i:%i\n",	(int)(((BYTE*)&IP)[0]),
															(int)(((BYTE*)&IP)[1]),
															(int)(((BYTE*)&IP)[2]),
															(int)(((BYTE*)&IP)[3]),
															Port);
*/	}

	// Send SessionKey
	BYTE buffer[6];
	LONG Key;

	Key = ~GetLong(Packet->Message, 2) + 1;
	MakeSessionKey(buffer, Key);

	Packet->Source->Send(buffer, 6, false);
	Packet->Source->SetKey(Key);

	// Enable a few of the other protocol components
	Packet->Source->SpecialRouter.RegisterHandler(3,	HandleReliable);
	Packet->Source->SpecialRouter.RegisterHandler(4,	HandleACK);
	Packet->Source->SpecialRouter.RegisterHandler(5,	HandleSyncRequest);
	Packet->Source->SpecialRouter.RegisterHandler(6,	HandleSyncResponse);
	Packet->Source->SpecialRouter.RegisterHandler(8,	HandleSmallChunkBody);
	Packet->Source->SpecialRouter.RegisterHandler(9,	HandleSmallChunkTail);
	Packet->Source->SpecialRouter.RegisterHandler(10,	HandleBigChunk);
	Packet->Source->SpecialRouter.RegisterHandler(14,	HandleCluster);

	return true;
}

bool HandleEncryptResponse	(PacketStruct * Packet)
{
	// Set SessionKey
	if (Packet->Source->SSEncrTable.SSKey == GetLong(Packet->Message, 2))
	{
		Packet->Source->InitializeEncryption(0);
		Packet->Source->Chat.AddMessage("WARNING: Encryption has been disabled.", CHAT_Orange);
	}
	else
	{
		if ((~Packet->Source->SentKey + 1) != (DWORD)GetLong(Packet->Message, 2))
		{
			Packet->Source->Chat.AddMessage("WARNING: Malformed encryption key.", CHAT_Orange);
		}

		Packet->Source->InitializeEncryption(GetLong(Packet->Message, 2));

		Packet->Source->Chat.AddMessage("Core-protocol handshake initiated.", CHAT_Grey);
	}

	Packet->Source->HasSession = true;

	// Enable a few of the other protocol components
	Packet->Source->SetSpecialHandler(3,	HandleReliable);
	Packet->Source->SetSpecialHandler(4,	HandleACK);
	Packet->Source->SetSpecialHandler(6,	HandleSyncResponse);
	Packet->Source->SetSpecialHandler(8,	HandleSmallChunkBody);
	Packet->Source->SetSpecialHandler(9,	HandleSmallChunkTail);
	Packet->Source->SetSpecialHandler(10,	HandleBigChunk);
	Packet->Source->SetSpecialHandler(14,	HandleCluster);

	Packet->Source->SetHandler(1,	HandleIDChange);		// TODO::
	Packet->Source->SetHandler(2,	HandleInGameFlag);
	Packet->Source->SetHandler(3,	HandlePlayerEntering);
	Packet->Source->SetHandler(4,	HandlePlayerLeaving);
	Packet->Source->SetHandler(5,	HandleWeaponsFire);
	Packet->Source->SetHandler(6,	HandlePlayerDeath);
	Packet->Source->SetHandler(7,	HandleChat);
	Packet->Source->SetHandler(8,	HandlePrizePickup);
	Packet->Source->SetHandler(9,	HandleScoreUpdate);
	Packet->Source->SetHandler(10,	HandlePasswordAccept);
	Packet->Source->SetHandler(11,	HandleSoccerGoal);
	Packet->Source->SetHandler(12,		HandleUnknown);		// ?
	Packet->Source->SetHandler(13,	HandleSetFreq);
	Packet->Source->SetHandler(14,	HandleTurretPlayer);
	Packet->Source->SetHandler(15,	HandleArenaSettings);
	Packet->Source->SetHandler(16,	HandleFileTransfer);
	Packet->Source->SetHandler(17,		HandleUnknown);		// ?
	Packet->Source->SetHandler(18,	HandleFlagPosition);
	Packet->Source->SetHandler(19,	HandleFlagClaim);
	Packet->Source->SetHandler(20,	HandleFlagVictory);
	Packet->Source->SetHandler(21,	HandleUnturret);
	Packet->Source->SetHandler(22,	HandleFlagDrop);
	Packet->Source->SetHandler(23,		HandleUnknown);		// ?
	Packet->Source->SetHandler(24,	HandleSecurityChecksum);
	Packet->Source->SetHandler(25,		HandleMapRequest);	// ?
	Packet->Source->SetHandler(26,	HandleScoreReset);
	Packet->Source->SetHandler(27,	HandleShipReset);
	Packet->Source->SetHandler(28,	HandleSpecPlayer);
	Packet->Source->SetHandler(29,	HandleSetFreqAndShip);
	Packet->Source->SetHandler(30,		HandleUnknown);		// ?
	Packet->Source->SetHandler(31,	HandlePlayerBanner);
	Packet->Source->SetHandler(32,	HandlePrize);
	Packet->Source->SetHandler(33,	HandleDoorToggle);
	Packet->Source->SetHandler(34,	HandleTurfFlagStatus);
	Packet->Source->SetHandler(35,	HandleFlagReward);
	Packet->Source->SetHandler(36,		HandleUnknown);		// ?
	Packet->Source->SetHandler(37,	HandleToggleUFO);
	Packet->Source->SetHandler(38,		HandleUnknown);		// ?
	Packet->Source->SetHandler(39,	HandleKeepAlive);
	Packet->Source->SetHandler(40,	HandlePlayerPosition);
	Packet->Source->SetHandler(41,	HandleMapInformation);
	Packet->Source->SetHandler(42,	HandleMapFile);
	Packet->Source->SetHandler(43,		HandleUnknown);		// ?
	Packet->Source->SetHandler(44,	HandleKoTHReset);
	Packet->Source->SetHandler(45,		HandleUnknown);		// ?
	Packet->Source->SetHandler(46,	HandleBallPosition);
	Packet->Source->SetHandler(47,	HandleArenaList);
	Packet->Source->SetHandler(48,	HandleBannerAds);
	Packet->Source->SetHandler(49,		HandleLoginUnknown);	// ?
	Packet->Source->SetHandler(50,		HandleStatusUnknown);	// 2 fields, at least one is a player ID
	Packet->Source->SetHandler(51,	HandleCustomMessage);

	// Send Login packet
	BYTE LoginPacket[101];
	MakeLogin(LoginPacket, Packet->Source->BotName, Packet->Source->BotPassword, Packet->Source->MachineID, Packet->Source->TZB, Packet->Source->PermissionID, false, 0);
	Packet->Source->Send(LoginPacket, 101, true);
	Packet->Source->PasswordWait = true;

	Packet->Source->Chat.AddMessage("Sent password packet.", CHAT_Grey);

	BYTE SyncPacket[14];
	MakeSyncRequest(SyncPacket, Packet->Source->GetLocalTime(), Packet->Source->TotalSent, Packet->Source->TotalRecvd);
	Packet->Source->Send(SyncPacket, 14, false);

	return true;
}

bool HandleReliable			(PacketStruct * Packet)
{
	//printf("Reliable: ");

	if (Packet->Length >= 7)
	{
		return (Packet->Source->CheckBacklog(Packet));
	}
	else
	{
		long IP = Packet->Source->Remote.IP;
		short Port = htons(Packet->Source->Remote.Port);
/*		printf("Malformed reliable header from %i.%i.%i.%i  Punt!\n",	(int)(((BYTE*)&IP)[0]),
																		(int)(((BYTE*)&IP)[1]),
																		(int)(((BYTE*)&IP)[2]),
																		(int)(((BYTE*)&IP)[3]));
*/		// Delete the host
		Packet->Source->Disconnect(false);

		return true;
	}
}

bool HandleACK				(PacketStruct * Packet)
{
	//printf("ACK Message\n");

	if (Packet->Length == 6)
	{
		Packet->Source->CheckPostlog(GetLong(Packet->Message, 2));
	}
	else
	{
		long IP = Packet->Source->Remote.IP;
		short Port = htons(Packet->Source->Remote.Port);
/*		printf("Malformed ACK from %i.%i.%i.%i  Punt!\n",	(int)(((BYTE*)&IP)[0]),
															(int)(((BYTE*)&IP)[1]),
															(int)(((BYTE*)&IP)[2]),
															(int)(((BYTE*)&IP)[3]));
*/		// Delete the host
		Packet->Source->Disconnect(false);
	}

	return true;
}

bool HandleSyncRequest		(PacketStruct * Packet)
{
	//printf("Sync Request\n");

	if (Packet->Length >= 6)
	{
		// Send a sync response
		BYTE buffer[10];
		MakeSyncResponse(buffer, GetLong(Packet->Message, 2), Packet->Source->GetLocalTime());
		Packet->Source->Send(buffer, 10, false);
	}
	else
	{
		long IP = Packet->Source->Remote.IP;
		short Port = htons(Packet->Source->Remote.Port);
/*		printf("Malformed sync request from %i.%i.%i.%i  Punt!\n",	(int)(((BYTE*)&IP)[0]),
																	(int)(((BYTE*)&IP)[1]),
																	(int)(((BYTE*)&IP)[2]),
																	(int)(((BYTE*)&IP)[3]));
*/		// Delete the host
		Packet->Source->Disconnect(false);
	}

	return true;
}

bool HandleSyncResponse		(PacketStruct * Packet)
{
	//printf("Sync Response\n");

	if (Packet->Length >= 10)
	{
		// Get sync
		Packet->Source->DiffTime = GetLong(Packet->Message, 6) - GetLong(Packet->Message, 2);
		Packet->Source->UpdatePing(GetTickCount() / 10 - GetLong(Packet->Message, 2));
	}
	else
	{
		long IP = Packet->Source->Remote.IP;
		short Port = htons(Packet->Source->Remote.Port);
/*		printf("Malformed sync response from %i.%i.%i.%i  Punt!\n",	(int)(((BYTE*)&IP)[0]),
																	(int)(((BYTE*)&IP)[1]),
																	(int)(((BYTE*)&IP)[2]),
																	(int)(((BYTE*)&IP)[3]));
*/		// Delete the host
		Packet->Source->Disconnect(false);
	}

	return true;
}

bool HandleDisconnect		(PacketStruct * Packet)
{
	// Display connection termination
	Packet->Source->Chat.AddMessage("WARNING: SubSpace host disconnected.", CHAT_Red);

	// Delete all lists
	Packet->Source->PlayerList.Clear(false);
	Packet->Source->PlayerQAL.ClearList();
	Packet->Source->SoccerList.Clear(false);
	Packet->Source->FlagList.Clear(false);
	Packet->Source->WeaponList.Clear(false);
	Packet->Source->BrickList.Clear(false);

	// Reconnect to SFSS Sub-icide
	Packet->Source->ResetSession();
	Packet->Source->Connect(((sockaddr_in*)&Packet->Source->Remote)->sin_addr.S_un.S_addr, htons(((sockaddr_in*)&Packet->Source->Remote)->sin_port));

	return true;
}

bool HandleSmallChunkBody	(PacketStruct * Packet)
{	// Chunk of packet
	//printf("Small Chunk Body\n");

	if (Packet->Length > 2)
	{
		Packet->Source->IncomingChunks.Append((char*)&Packet->Message[2], Packet->Length - 2);
	}
	else
	{
		long IP = Packet->Source->Remote.IP;
		short Port = htons(Packet->Source->Remote.Port);
/*		printf("Malformed small chunk body from %i.%i.%i.%i  Punt!\n",	(int)(((BYTE*)&IP)[0]),
																		(int)(((BYTE*)&IP)[1]),
																		(int)(((BYTE*)&IP)[2]),
																		(int)(((BYTE*)&IP)[3]));
*/		// Delete the host
		Packet->Source->Disconnect(false);
	}

	return true;
}

bool HandleSmallChunkTail	(PacketStruct * Packet)
{	// Last in a series of packet chunks
	//printf("Chunk recv'd\n");

	if (Packet->Length > 2)
	{
		Packet->Source->IncomingChunks.Append((char*)&Packet->Message[2], Packet->Length - 2);

		Packet->Source->Route((BYTE*)Packet->Source->IncomingChunks.Contents, Packet->Source->IncomingChunks.Length);

		Packet->Source->IncomingChunks.Clear();
	}
	else
	{
		long IP = Packet->Source->Remote.IP;
		short Port = htons(Packet->Source->Remote.Port);
/*		printf("Malformed small chunk tail from %i.%i.%i.%i  Punt!\n",	(int)(((BYTE*)&IP)[0]),
																		(int)(((BYTE*)&IP)[1]),
																		(int)(((BYTE*)&IP)[2]),
																		(int)(((BYTE*)&IP)[3]));
*/		// Delete the host
		Packet->Source->Disconnect(false);
	}

	return true;
}

bool HandleBigChunk			(PacketStruct * Packet)
{	// BIG chunk fragment
	//printf("Big Chunk Frag\n");

	if (Packet->Length > 6)
	{
		Packet->Source->BIGChunks.Append((char*)&Packet->Message[6], Packet->Length - 6);

		if (Packet->Source->BIGChunks.Length == GetLong(Packet->Message, 2))
		{
			Packet->Source->Route((BYTE*)Packet->Source->BIGChunks.Contents, GetLong(Packet->Message, 2));

			Packet->Source->BIGChunks.Clear();
		}
	}
	else
	{
		long IP = Packet->Source->Remote.IP;
		short Port = htons(Packet->Source->Remote.Port);
/*		printf("Malformed big chunk from %i.%i.%i.%i  Punt!\n",	(int)(((BYTE*)&IP)[0]),
																(int)(((BYTE*)&IP)[1]),
																(int)(((BYTE*)&IP)[2]),
																(int)(((BYTE*)&IP)[3]));
*/		// Delete the host
		Packet->Source->Disconnect(false);

		return true;
	}

	return true;
}

bool HandleCluster			(PacketStruct * Packet)
{	// Clump of packets
	//printf("Cluster\n");

	DWORD Offset = 2;

	while (Offset < Packet->Length)
	{
		if (!Packet->Message[Offset] || ((Offset + Packet->Message[Offset]) >= Packet->Length))
		{
			long IP = Packet->Source->Remote.IP;
			short Port = htons(Packet->Source->Remote.Port);
/*			printf("Malformed cluster from %i.%i.%i.%i  Punt!\n",	(int)(((BYTE*)&IP)[0]),
																	(int)(((BYTE*)&IP)[1]),
																	(int)(((BYTE*)&IP)[2]),
																	(int)(((BYTE*)&IP)[3]));
*/			// Delete the host
			Packet->Source->Disconnect(false);

			return true;
		}

		// Route packet
		Packet->Source->Route(&Packet->Message[Offset + 1], (SHORT)Packet->Message[Offset]);

		// Calculate next offset
		Offset += Packet->Message[Offset];
		Offset++;
	}

	return true;
}

bool HandleSpecial			(PacketStruct * Packet)
{
	//printf("Special: ");

	if (Packet->Length > 1)
	{
		Packet->Source->SpecialRouter.CallHandler(Packet->Message[1], Packet);

		return false;
	}
	else
	{
		long IP = Packet->Source->Remote.IP;
		short Port = htons(Packet->Source->Remote.Port);
/*		printf("Malformed special header from %i.%i.%i.%i  Punt!\n",	(int)(((BYTE*)&IP)[0]),
																		(int)(((BYTE*)&IP)[1]),
																		(int)(((BYTE*)&IP)[2]),
																		(int)(((BYTE*)&IP)[3]));
*/		// Delete the host
		Packet->Source->Disconnect(false);

		return true;
	}
}

bool HandleUnknown			(PacketStruct * Packet)
{
	_string s;
	s = "Unhandled packet(";
	s += (int)Packet->Message[0];
	s += ")(";
	s += (int)Packet->Length;
	s += ") - Logged to disk as unknownpacket.bin";

	Packet->Source->Chat.AddMessage(s.Text, CHAT_Red);
	Packet->Source->SendPublicChat(s.Text);

	LONG fnFile = _open("unknownpacket.bin", _O_BINARY | _O_CREAT | _O_WRONLY, _S_IWRITE);
	_write(fnFile, Packet->Message, Packet->Length);
	_close(fnFile);

	return true;
}
